﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Data;

using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;

using System.Net;
using System.Web.Script.Serialization;


using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Configuration;

public partial class AddNewQuestion : System.Web.UI.Page
{
    String conStr = ConfigurationManager.ConnectionStrings["techfitConnectionStringNonODB"].ConnectionString.ToString();
    String conOLDBStr = ConfigurationManager.ConnectionStrings["techfitConnectionString"].ConnectionString.ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
    Page.MaintainScrollPositionOnPostBack = true;
        try
        {
             // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role!=1 && role!=2 && role!=5){
                Response.Redirect("Default.aspx");
            }
            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
            if (!this.IsPostBack)
            {

                this.BindRepeaterConcepts();
                this.BindRepeaterHabits();
                this.BindRepeaterPractices();
            }
        }
        catch (Exception exception)
        {
            Response.Redirect("Default.aspx");
        }


    }

    protected void logout(object sender, EventArgs e)
    {
        Session["ContributorID"] = null;
        Session["ContributorName"] = null;
        Session["ContributorWelcomeMsg"] = null;
        Session["Role"] = null;
        Session["questionID"] = null;
        Session["questionType"] = null;
        Session["UserID"] = null;
        Session["Name"] = null;
        Session["Type"] = null;
        Session["GradeLevel"] = null;
        Session["score"] = null;
        Session["studentID"] = null;
        Session["correctAnswerListAsString"] = null;
        Session["incorrectAnswerListAsString"] = null;
        Response.Redirect("Default.aspx");
    }


    protected void categorySA(object sender, EventArgs e)
    {
        Response.Redirect("CTSingleAnswer.aspx");
    }
    
    protected void btnCancelNewUser_Click(object sender, EventArgs e)
    {
        Response.Redirect("CTLanding.aspx");
    }
    protected void btnAddNewUser_Click(object sender, EventArgs e)
    {

      
        
        
    }
    protected void goBack(object sender, EventArgs e)
    {
        // Adapt page depending on rol  e
            int role = Convert.ToInt32(Session["Role"].ToString());
            //Admin
            if (role == 1)
            {
                Response.Redirect("CTAdminLanding.aspx");
            }
            else if(role==2){
                Response.Redirect("CTTeacherLanding.aspx");
            }
            else{
                Response.Redirect("CTLanding.aspx");
            }
        
    }

  private void ClearAll()
        {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
        }

    // Helper method to filter the user's input
    private string toSQL(string stringValue)
    {
        string temp = stringValue.Replace("'", "''");
        temp = temp.Replace("<", "");
        temp = temp.Replace(">", "");
        temp = temp.Replace(";", " ");
        temp = temp.Replace(" OR ", " ");

        return "'" + temp + "'";
    }

    private void BindRepeaterConcepts()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT ConceptID, ConceptName FROM ct_questions.CT_Concepts";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvConcepts.DataSource = dt;
                    lvConcepts.DataBind();
                }
            }
        }
    }

    private void BindRepeaterHabits()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT HabitId, HabitName FROM ct_questions.CT_Habits";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvHabits.DataSource = dt;
                    lvHabits.DataBind();
                }
            }
        }
    }

    private void BindRepeaterPractices()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT PracticeId, PracticeName FROM ct_questions.CT_Practices";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvPractices.DataSource = dt;
                    lvPractices.DataBind();
                }
            }
        }
    }

    public static String GetTimestamp(DateTime value)
    {
        return value.ToString("yyyyMMddHHmmssffff");
    }

    protected void upload(object sender, EventArgs e)
    {
        
        if (FileUpload1.HasFile)
        {
            //string fileName = Path.GetFileName(FileUpload1.PostedFile.FileName);
            //FileUpload1.PostedFile.SaveAs(Server.MapPath("~/Data/" + fileName));
            String timeStamp = GetTimestamp(DateTime.Now);
            timeStamp = timeStamp + ".jpg";
            FileUpload1.PostedFile.SaveAs(Server.MapPath("~/Data/CT/Images/" + timeStamp));
            //FileUpload1.PostedFile.SaveAs(Server.MapPath("~/CTQuestions/") + fileName);
            //Response.Redirect(Request.Url.AbsoluteUri);
            fileTypeName.Value = "../Data/CT/Images/" + timeStamp; 
            uploaded.Text = "File uploaded!";
        }
    }

    protected void uploadSA(object sender, EventArgs e)
    {
        
        if (FileUploadSA.HasFile)
        {
            //string fileName = Path.GetFileName(FileUpload1.PostedFile.FileName);
            //FileUpload1.PostedFile.SaveAs(Server.MapPath("~/Data/" + fileName));
            String timeStamp = GetTimestamp(DateTime.Now);
            timeStamp = timeStamp + ".jpg";
            FileUploadSA.PostedFile.SaveAs(Server.MapPath("~/Data/CT/Images/" + timeStamp));
            //FileUpload1.PostedFile.SaveAs(Server.MapPath("~/CTQuestions/") + fileName);
            //Response.Redirect(Request.Url.AbsoluteUri);
            fileTypeNameSA.Value = "../Data/CT/Images/" + timeStamp; 
            uploadedSA.Text = "File uploaded!";
        }
    }


    protected void singleAnswerInsertButton_Click(object sender, EventArgs e)
    {
        OleDbConnection db = null;
        int qID = 0, rated=0;

        try
        {
            String contIdStr = Session["ContributorID"].ToString();
            String fileTypeNameStr = fileTypeNameSA.Value;
            String textualDifficultyLevelStr = textualDifficultyLevel.SelectedValue;
            String textualInsertQNotesStr = textualInsertQNotes.Text;
            String textualInsertQuestionStr = textualInsertQuestion.Text;
            String textualInsertQAnswerStr = textualInsertQAnswer.Text;
            String textualInsertQSourceStr = textualInsertQSource.Text;


            // Validation
            Regex myFilter = new Regex("[0-9a-zA-Z-_,@;]");


            if (textualInsertQuestionStr == "")
            {
                lblErr.Text = "Question is required!";
                textualInsertQuestion.Focus();
                return;
            }


            if (!myFilter.IsMatch(textualInsertQuestionStr))
            {
                lblErr.Text = "The question you entered is invalid!";
                return;
            }

            if (textualInsertQAnswerStr == "")
            {
                lblErr.Text = "Answer is required!";
                textualInsertQAnswer.Focus();
                return;
            }

            if (!myFilter.IsMatch(textualInsertQAnswerStr))
            {
                lblErr.Text = "The answer you entered is invalid!";
                return;
            }

            if (textualDifficultyLevel.SelectedIndex == 0)
            {
                lblErr.Text = "Select a valid difficulty level!";
                textualDifficultyLevel.Focus();
                return;
            }

                foreach (RepeaterItem item in lvConcepts.Items)
            {
                DropDownList lvConceptDropdown = (DropDownList)item.FindControl("lvConceptDropdown");
                if (Convert.ToInt32(lvConceptDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            foreach (RepeaterItem item in lvHabits.Items)
            {
                DropDownList lvHabitsDropdown = (DropDownList)item.FindControl("lvHabitsDropdown");
                if (Convert.ToInt32(lvHabitsDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            foreach (RepeaterItem item in lvPractices.Items)
            {
                DropDownList lvPracticesDropdown = (DropDownList)item.FindControl("lvPracticesDropdown");
                if (Convert.ToInt32(lvPracticesDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            if (rated == 0)
            {
                lblErr.Text = "You must rate at least one Concept, Habit or Practice!";
                return;
            }




            db = new OleDbConnection();
            db.ConnectionString = conOLDBStr;
            db.Open();

            // For CT_Questions
            OleDbCommand cmdQuestions = db.CreateCommand();
            cmdQuestions.CommandText = "insert into ct_questions.CT_Questions values ('SA', ?, ?, ?, ?)";
            cmdQuestions.Parameters.AddWithValue("@textualDifficultyLevelStr", textualDifficultyLevelStr);
            cmdQuestions.Parameters.AddWithValue("@contIdStr", contIdStr);
            cmdQuestions.Parameters.AddWithValue("@textualInsertQNotesStr", textualInsertQNotesStr);
            cmdQuestions.Parameters.AddWithValue("@textualInsertQSourceStr", textualInsertQSourceStr);
            cmdQuestions.ExecuteNonQuery();

            String queryQID = "SELECT @@IDENTITY";
            OleDbCommand cmdQID = new OleDbCommand(queryQID, db);
            qID = Convert.ToInt32(cmdQID.ExecuteScalar());



            // For CT_Question_SA
            OleDbCommand cmdQuestionsSA = db.CreateCommand();
            cmdQuestionsSA.CommandText = "insert into ct_questions.CT_Question_SA values (?, ?, ?, ?, ?)";
            cmdQuestionsSA.Parameters.AddWithValue("@qID", qID);
            cmdQuestionsSA.Parameters.AddWithValue("@textualInsertQuestionStr", textualInsertQuestionStr);
            cmdQuestionsSA.Parameters.AddWithValue("@textualInsertQAnswerStr", textualInsertQAnswerStr);
            cmdQuestionsSA.Parameters.AddWithValue("@textualInsertQNotesStr", textualInsertQNotesStr);
            cmdQuestionsSA.Parameters.AddWithValue("@fileTypeNameStr", fileTypeNameStr);
            cmdQuestionsSA.ExecuteNonQuery();


            // For Concepts

            foreach (RepeaterItem item in lvConcepts.Items)
            {
                DropDownList lvConceptDropdown = (DropDownList)item.FindControl("lvConceptDropdown");
                HiddenField lvConceptId = (HiddenField)item.FindControl("lvConceptId");
                String conceptId = lvConceptId.Value;

                if (Convert.ToInt32(lvConceptDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionConcept = db.CreateCommand();
                    cmdQuestionConcept.CommandText = "insert into ct_questions.CT_QuestionConcept values (?, ?, ?, ?)";
                    cmdQuestionConcept.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionConcept.Parameters.AddWithValue("@conceptID", conceptId);
                    cmdQuestionConcept.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionConcept.Parameters.AddWithValue("@textualComplexityStr", Convert.ToInt32(lvConceptDropdown.SelectedValue));
                    cmdQuestionConcept.ExecuteNonQuery();
                }


            }



            // For Habits

            foreach (RepeaterItem item in lvHabits.Items)
            {
                DropDownList lvHabitsDropdown = (DropDownList)item.FindControl("lvHabitsDropdown");
                HiddenField lvHabitId = (HiddenField)item.FindControl("lvHabitId");
                String habitId = lvHabitId.Value;

                if (Convert.ToInt32(lvHabitsDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionHabit = db.CreateCommand();
                    cmdQuestionHabit.CommandText = "insert into ct_questions.CT_QuestionHabit values (?, ?, ?, ?)";
                    cmdQuestionHabit.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionHabit.Parameters.AddWithValue("@habitID", habitId);
                    cmdQuestionHabit.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionHabit.Parameters.AddWithValue("@textualComplexityStr", Convert.ToInt32(lvHabitsDropdown.SelectedValue));
                    cmdQuestionHabit.ExecuteNonQuery();
                }


            }

            // For Practices

            foreach (RepeaterItem item in lvPractices.Items)
            {
                DropDownList lvPracticesDropdown = (DropDownList)item.FindControl("lvPracticesDropdown");
                HiddenField lvPracticeId = (HiddenField)item.FindControl("lvPracticeId");
                String practiceId = lvPracticeId.Value;

                if (Convert.ToInt32(lvPracticesDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionPractice = db.CreateCommand();
                    cmdQuestionPractice.CommandText = "insert into ct_questions.CT_QuestionPractice values (?, ?, ?, ?)";
                    cmdQuestionPractice.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionPractice.Parameters.AddWithValue("@practiceID", practiceId);
                    cmdQuestionPractice.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionPractice.Parameters.AddWithValue("@textualComplexityStr", Convert.ToInt32(lvPracticesDropdown.SelectedValue));
                    cmdQuestionPractice.ExecuteNonQuery();
                }

            }
            db.Close();

            StringBuilder sb = new StringBuilder();
            String message="Question added!";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "'); window.open('CTAddNewQuestion.aspx','_self');");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again!";
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception;
        }

    }

    protected void multipleChoiceInsertButton_Click(object sender, EventArgs e)
    {
        OleDbConnection db = null;
        int qID = 0, rated=0;

        try
        {
            String contIdStr = Session["ContributorID"].ToString();
            String fileTypeNameStr = fileTypeName.Value;
            String multipleChoiceInsertQuestionStr = multipleChoiceInsertQuestion.Text;
            String multipleChoiceNbrStr = multipleChoiceNbr.SelectedValue;
            String choice1 = null;
            String choice2 = null;
            String choice3 = null;
            String choice4 = null;
            String choice5 = null;
            String choice6 = null;
            String choice7 = null;
            String choice8 = null;
            String choice9 = null;
            String choice10 = null;
            String multipleChoiceInsertQAnswerStr = multipleChoiceInsertQAnswer.Text;
            String multipleChoiceInsertQNotesStr = multipleChoiceInsertQNotes.Text;
            String multipleChoiceInsertQSourceStr = multipleChoiceInsertQSource.Text;
            String multipleChoiceDifficultyLevelStr = multipleChoiceDifficultyLevel.SelectedValue;
            int i=0, remainingChoices=0, invalidChoces=0;

            // Validation
            Regex myFilter = new Regex("[0-9a-zA-Z-_,@;]");


            if (multipleChoiceInsertQuestionStr == "")
            {
                lblErr.Text = "Question is required!";
                multipleChoiceInsertQuestion.Focus();
                return;
            }

             if (!myFilter.IsMatch(multipleChoiceInsertQuestionStr))
            {
                lblErr.Text = "The question you entered is invalid!";
                return;
            }

            if (multipleChoiceNbr.SelectedIndex == 0)
            {
                lblErr.Text = "Select a valid choice number!";
                multipleChoiceNbr.Focus();
                return;
            }

            foreach (RepeaterItem item in mcqRepeat.Items)
            {
                TextBox txtName= (TextBox)item.FindControl("multipleChoice");
                if(txtName.Text=="")
                {
                    invalidChoces=1;
                }
            }

            if (invalidChoces == 1)
            {
                lblErr.Text = "Enter all the choices!";
                return;
            }

            if (multipleChoiceDifficultyLevel.SelectedIndex == 0)
            {
                lblErr.Text = "Select a valid difficulty level!";
                multipleChoiceDifficultyLevel.Focus();
                return;
            }

            if (multipleChoiceInsertQAnswerStr == "")
            {
                lblErr.Text = "Answer is required!";
                multipleChoiceInsertQAnswer.Focus();
                return;
            }

            if (!myFilter.IsMatch(multipleChoiceInsertQAnswerStr))
            {
                lblErr.Text = "The answer you entered is invalid!";
                return;
            }

            foreach (RepeaterItem item in lvConcepts.Items)
            {
                DropDownList lvConceptDropdown = (DropDownList)item.FindControl("lvConceptDropdown");
                if (Convert.ToInt32(lvConceptDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            foreach (RepeaterItem item in lvHabits.Items)
            {
                DropDownList lvHabitsDropdown = (DropDownList)item.FindControl("lvHabitsDropdown");
                if (Convert.ToInt32(lvHabitsDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            foreach (RepeaterItem item in lvPractices.Items)
            {
                DropDownList lvPracticesDropdown = (DropDownList)item.FindControl("lvPracticesDropdown");
                if (Convert.ToInt32(lvPracticesDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            if (rated == 0)
            {
                lblErr.Text = "You must rate at least one Concept, Habit or Practice!";
                return;
            }

            db = new OleDbConnection();
            db.ConnectionString = "Provider=SQLOLEDB;Server=ecnmssqldev.ecn.purdue.edu;Database=dev.techfit;Integrated Security=SSPI";
            db.Open();

            // For CT_Questions
            OleDbCommand cmdQuestions = db.CreateCommand();
            cmdQuestions.CommandText = "insert into ct_questions.CT_Questions values ('MC', ?, ?, ?, ?)";
            cmdQuestions.Parameters.AddWithValue("@multipleChoiceDifficultyLevelStr", multipleChoiceDifficultyLevelStr);
            cmdQuestions.Parameters.AddWithValue("@contIdStr", contIdStr);
            cmdQuestions.Parameters.AddWithValue("@multipleChoiceInsertQNotesStr", multipleChoiceInsertQNotesStr);
            cmdQuestions.Parameters.AddWithValue("@multipleChoiceInsertQSourceStr", multipleChoiceInsertQSourceStr);          
            cmdQuestions.ExecuteNonQuery();

            String queryQID = "SELECT @@IDENTITY";
            OleDbCommand cmdQID = new OleDbCommand(queryQID, db);
            qID = Convert.ToInt32(cmdQID.ExecuteScalar());



            // For CT_Question_MC
            OleDbCommand cmdQuestionsMC = db.CreateCommand();
            cmdQuestionsMC.CommandText = "insert into ct_questions.CT_Question_MC values (?, ?, ?, ?, ?, ?, ?, ?, ?, ? ,?, ?, ?, ?, ?, ?)";
            cmdQuestionsMC.Parameters.AddWithValue("@qID", qID);
            cmdQuestionsMC.Parameters.AddWithValue("@multipleChoiceInsertQuestionStr", multipleChoiceInsertQuestionStr);
            cmdQuestionsMC.Parameters.AddWithValue("@multipleChoiceNbrStr", multipleChoiceNbrStr);


            foreach (RepeaterItem item in mcqRepeat.Items)
            {
                TextBox txtName= (TextBox)item.FindControl("multipleChoice");
                if(txtName.Text!=null)
                {
                //do something with txtName.Text
                cmdQuestionsMC.Parameters.AddWithValue("@choice", "> "+txtName.Text);
                }
            }
            remainingChoices = 10-mcqRepeat.Items.Count;
            for(i=1;i<=remainingChoices;i++){
                cmdQuestionsMC.Parameters.AddWithValue("@choice", null);
            }
            cmdQuestionsMC.Parameters.AddWithValue("@multipleChoiceInsertQAnswerStr", "> "+multipleChoiceInsertQAnswerStr);
            cmdQuestionsMC.Parameters.AddWithValue("@multipleChoiceInsertQNotesStr", multipleChoiceInsertQNotesStr);
            cmdQuestionsMC.Parameters.AddWithValue("@fileTypeNameStr", fileTypeNameStr);
            cmdQuestionsMC.ExecuteNonQuery();


            // For Concepts

            foreach (RepeaterItem item in lvConcepts.Items)
            {
                DropDownList lvConceptDropdown = (DropDownList)item.FindControl("lvConceptDropdown");
                HiddenField lvConceptId = (HiddenField)item.FindControl("lvConceptId");
                String conceptId = lvConceptId.Value;

                if (Convert.ToInt32(lvConceptDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionConcept = db.CreateCommand();
                    cmdQuestionConcept.CommandText = "insert into ct_questions.CT_QuestionConcept values (?, ?, ?, ?)";
                    cmdQuestionConcept.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionConcept.Parameters.AddWithValue("@conceptID", conceptId);
                    cmdQuestionConcept.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionConcept.Parameters.AddWithValue("@textualComplexityStr", Convert.ToInt32(lvConceptDropdown.SelectedValue));
                    cmdQuestionConcept.ExecuteNonQuery();
                }


            }



            // For Habits

            foreach (RepeaterItem item in lvHabits.Items)
            {
                DropDownList lvHabitsDropdown = (DropDownList)item.FindControl("lvHabitsDropdown");
                HiddenField lvHabitId = (HiddenField)item.FindControl("lvHabitId");
                String habitId = lvHabitId.Value;

                if (Convert.ToInt32(lvHabitsDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionHabit = db.CreateCommand();
                    cmdQuestionHabit.CommandText = "insert into ct_questions.CT_QuestionHabit values (?, ?, ?, ?)";
                    cmdQuestionHabit.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionHabit.Parameters.AddWithValue("@habitID", habitId);
                    cmdQuestionHabit.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionHabit.Parameters.AddWithValue("@textualComplexityStr", Convert.ToInt32(lvHabitsDropdown.SelectedValue));
                    cmdQuestionHabit.ExecuteNonQuery();
                }


            }

            // For Practices

            foreach (RepeaterItem item in lvPractices.Items)
            {
                DropDownList lvPracticesDropdown = (DropDownList)item.FindControl("lvPracticesDropdown");
                HiddenField lvPracticeId = (HiddenField)item.FindControl("lvPracticeId");
                String practiceId = lvPracticeId.Value;

                if (Convert.ToInt32(lvPracticesDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionPractice = db.CreateCommand();
                    cmdQuestionPractice.CommandText = "insert into ct_questions.CT_QuestionPractice values (?, ?, ?, ?)";
                    cmdQuestionPractice.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionPractice.Parameters.AddWithValue("@practiceID", practiceId);
                    cmdQuestionPractice.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionPractice.Parameters.AddWithValue("@textualComplexityStr", Convert.ToInt32(lvPracticesDropdown.SelectedValue));
                    cmdQuestionPractice.ExecuteNonQuery();
                }


            }

            db.Close();
            StringBuilder sb = new StringBuilder();
            String message="Question added!";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "');window.open('CTAdminLanding.aspx','_self');");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again!";
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.Message;
        }

    }

    protected void questionType_SelectedIndexChanged(object sender, EventArgs e)
    {
        String selVal = questionType.SelectedValue;
        if(selVal=="Short Answer"){
            singleAnswerDiv.Visible = true;
            multipleAnswerDiv.Visible = false;
            ratingAndCommonDiv.Visible = true;
            singleAnswerSubmitDiv.Visible = true;
            multipleChoiceSubmitDiv.Visible = false;
        } else if(selVal=="Multiple Choice"){
            singleAnswerDiv.Visible = false;
            multipleAnswerDiv.Visible = true;
            ratingAndCommonDiv.Visible = true;
            multipleChoiceSubmitDiv.Visible = true;
            singleAnswerSubmitDiv.Visible = false;

        } else if(selVal=="Image"){
            singleAnswerDiv.Visible = false;
            multipleAnswerDiv.Visible = false;
            ratingAndCommonDiv.Visible = true;
            singleAnswerSubmitDiv.Visible = false;
            multipleChoiceSubmitDiv.Visible = false;

        } else {
            singleAnswerDiv.Visible = false;
            multipleAnswerDiv.Visible = false;
            ratingAndCommonDiv.Visible = false;
            singleAnswerSubmitDiv.Visible = false;
            multipleChoiceSubmitDiv.Visible = false;

        }
    }

    protected void multipleChoiceNbr_SelectedIndexChanged(object sender, EventArgs e)
    {
        
        DataTable dt = new DataTable();
        dt.Columns.Add("TextBox");
        int count = Convert.ToInt32(multipleChoiceNbr.SelectedItem.Value);
        for (int i = 0; i < count; i++)
        {
            dt.Rows.Add("");
        }
        this.mcqRepeat.DataSource = dt;
        this.mcqRepeat.DataBind();
    }

    
}