﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Data;

using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;

using System.Net;
using System.Web.Script.Serialization;


using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Configuration;
using System.Web.Helpers;


    public partial class AddNewUser : System.Web.UI.Page
    {
        String conOLDBStr = ConfigurationManager.ConnectionStrings["techfitConnectionString"].ConnectionString.ToString();

        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                 // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role!=1){
            Response.Redirect("Default.aspx");
            }
                Page.MaintainScrollPositionOnPostBack = true;
                welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
                BindSchoolDropdown();
            }
            catch (Exception exception)
            {
                Response.Redirect("Default.aspx");
            }


        }

        private void BindSchoolDropdown(){
            SqlDataSource13.SelectCommand = "SELECT id, SchoolName FROM ct_questions.[CT_School] ORDER BY [SchoolName] ASC";
            SqlDataSource13.DataBind();
        }

        protected void logout(object sender, EventArgs e)
        {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Response.Redirect("Default.aspx");
        }


        protected void categorySA(object sender, EventArgs e)
        {
            Response.Redirect("CTSingleAnswer.aspx");
        }
        
        protected void btnCancelNewUser_Click(object sender, EventArgs e)
        {
            Response.Redirect("CTLanding.aspx");
        }

        protected void position_Change(object sender, EventArgs e)
        {
            String selVal = userRole.SelectedValue;
            if(selVal=="Teacher"){
                gradeLevelDiv.Visible = false;
                schoolDiv.Visible = true;
            } else if(selVal=="Student"){
                gradeLevelDiv.Visible = true;
                schoolDiv.Visible = true;
            }  else {
                gradeLevelDiv.Visible = false;
                schoolDiv.Visible = false;
            }
        }
        protected void btnAddNewUser_Click(object sender, EventArgs e)
        {

            string sql = "";
            lblErr.Text = "";

            // Set up a regular expression to filter out invalid name characters.
            Regex myFilter = new Regex("[0-9a-zA-Z-_]");

            String firstName = txtFirstName.Text;
            String lastName = txtLastName.Text;
            String username = txtUsername.Text;
            String pass = txtPassword.Text;
            String role = userRole.SelectedValue;
            String email = txtEmail.Text;
            String contact = txtContactNumber.Text;
            String gradeLevel = gradeLevelDrop.SelectedValue;
            String school = schoolDropDown.SelectedValue; 
            
            int roleAsNumber = 4;


            if (firstName == "")
            {
                lblResult.Text = "First name is required.";
                txtFirstName.Focus();
                return;
            }

            if (lastName == "")
            {
                lblResult.Text = "Last name is required.";
                txtLastName.Focus();
                return;
            }

            if (contact == "")
            {
                lblResult.Text = "Contact Number is required.";
                txtContactNumber.Focus();
                return;
            }

            if (email == "")
            {
                lblResult.Text = "Email is required.";
                txtEmail.Focus();
                return;
            }

            if (username == "")
            {
                lblResult.Text = "Username is required.";
                txtUsername.Focus();
                return;
            }


            if (!myFilter.IsMatch(username))
            {
                lblResult.Text = "Please enter a combination of letters, numbers and special characters (-, _)";
                return;
            }

            
            if (pass == "")
            {
                lblResult.Text = "Password is required.";
                txtPassword.Focus();
                return;
            }

            myFilter = new Regex("[0-9a-zA-Z'-_!]*");

            if (!myFilter.IsMatch(pass))
            {
                lblResult.Text = "Please enter a combination of letters, numbers and special characters (', -, _, !)";
                return;
            }

            if (userRole.SelectedIndex == 0)
            {
                lblErr.Text = "Select a valid role!";
                userRole.Focus();
                return;
            } 
            else
            {   
                if(role.Equals("Administrator"))
                {
                    roleAsNumber=1;
                } else if (role.Equals("Teacher"))
                {
                    roleAsNumber=2;
                } else if (role.Equals("Student"))
                {
                    roleAsNumber=3;
                } else if (role.Equals("Expert"))
                {
                    roleAsNumber=4;
                } else if (role.Equals("Contributor"))
                {
                    roleAsNumber=5;
                } else if (role.Equals("Viewer"))
                {
                    roleAsNumber=6;
                }

            }

            //Encrypt Password
            string passHash = Crypto.HashPassword(pass);

            // Add user in DB
            OleDbConnection db = new OleDbConnection();
            db.ConnectionString = conOLDBStr;

            try
            {

                // Check if username exists

                db.Open();
                sql = "SELECT * FROM ct_questions.CT_Contributors WHERE [Username] = " + toSQL(username);

                OleDbCommand cmd = new OleDbCommand(sql, db);
                OleDbDataReader rdr = cmd.ExecuteReader();

                // If a match is found, assign the session variable to signify authorized.
                if (rdr.Read() == true)
                {
                    lblResult.Text = "Username already exists!";
                    rdr.Close();
                    db.Close();
                } else
                {
                    db.Close();
                    // Add user into DB

                    db.Open();
                    OleDbCommand cmdContributors = db.CreateCommand();
                    cmdContributors.CommandText = "insert into ct_questions.CT_Contributors values (?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
                    cmdContributors.Parameters.AddWithValue("@user", firstName+" "+lastName);
                    cmdContributors.Parameters.AddWithValue("@username", username);
                    cmdContributors.Parameters.AddWithValue("@pass", passHash);
                    cmdContributors.Parameters.AddWithValue("@role", roleAsNumber);
                    cmdContributors.Parameters.AddWithValue("@firstName", firstName);
                    cmdContributors.Parameters.AddWithValue("@lastName", lastName);
                    cmdContributors.Parameters.AddWithValue("@contact", contact);
                    cmdContributors.Parameters.AddWithValue("@email", email);
                    if (gradeLevelDrop.SelectedIndex!=0)
                    {
                        cmdContributors.Parameters.AddWithValue("@gradeLevel", gradeLevel);
                    } else
                    {
                        cmdContributors.Parameters.AddWithValue("@gradeLevel", null);
                    }
                    if (schoolDropDown.SelectedIndex!=0)
                    {
                        cmdContributors.Parameters.AddWithValue("@school", school);
                    } else
                    {
                        cmdContributors.Parameters.AddWithValue("@school", null);
                    }
                    

                    cmdContributors.ExecuteNonQuery();

                    StringBuilder sb = new StringBuilder();
                    String message="User added!";
                    sb.Append("<script type='text/javascript'>");
                    sb.Append("alert('" + message + "');window.open('CTAdminAddNewUser.aspx','_self');");
                    sb.Append("</script>");
                    ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
                    
                }
            }
            catch (Exception err)
            {
                lblResult.Text = "ERROR: There was a problem - " + err.Message + err.StackTrace;
            }
            finally
            {
                db.Close();
                
            }
            
            
        }
        protected void goBack(object sender, EventArgs e)
        {
            Response.Redirect("CTAdminLanding.aspx");
        }

     private void ClearAll()
        {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
        }

        // Helper method to filter the user's input
        private string toSQL(string stringValue)
        {
            string temp = stringValue.Replace("'", "''");
            temp = temp.Replace("<", "");
            temp = temp.Replace(">", "");
            temp = temp.Replace(";", " ");
            temp = temp.Replace(" OR ", " ");

            return "'" + temp + "'";
        }



        protected void GridView1_RowUpdating(object sender, GridViewUpdateEventArgs e)
        {    
            //SqlDataSource1.UpdateCommand="UPDATE ct_questions.[CT_Contributors] SET [ContributorName] = @ContributorName, [Username] = @Username, [Password] = @passEnc, [Role] = @Role, [FirstName] = @firstName, [LastName] = @LastName, [ContactNumber] = @ContactNumber, [Email] = @email , [GradeLevel] = @GradeLevel WHERE [ContributorID] = @original_ContributorID";
            SqlDataSource1.UpdateParameters["passHash"].DefaultValue = Crypto.HashPassword(e.NewValues["Password"].ToString());
            SqlDataSource1.UpdateParameters["ContributorName"].DefaultValue = e.NewValues["FirstName"].ToString() + " " + e.NewValues["LastName"].ToString();     
        
        }




        protected void SqlDataSource1_Selecting(object sender, SqlDataSourceSelectingEventArgs e)
        {

        }

        protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }