﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;
using System.Net;
using System.Web.Script.Serialization;
using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;

public partial class CTQuestionsCB : System.Web.UI.Page
{
    String conStr = ConfigurationManager.ConnectionStrings["techfitConnectionStringNonODB"].ConnectionString.ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role!=1){
                Response.Redirect("Default.aspx");
            }

            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
            if (!this.IsPostBack)
            {
                this.BindRepeaterConcepts();
                this.BindRepeaterHabits();
                this.BindRepeaterPractices();
                this.getCountAllQuestions();
            }

            // Show hide elements on page load
            SMFDiv.Visible=false;
        }
        catch (Exception exception)
        {
            Response.Redirect("Default.aspx");
        }
    }


    private void BindRepeaterConcepts()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT ConceptID, ConceptName FROM ct_questions.CT_Concepts";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvConcepts.DataSource = dt;
                    lvConcepts.DataBind();
                }
            }
        }
    }

    private void BindRepeaterHabits()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT HabitId, HabitName FROM ct_questions.CT_Habits";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvHabits.DataSource = dt;
                    lvHabits.DataBind();
                }
            }
        }
    }

    private void BindRepeaterPractices()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT PracticeId, PracticeName FROM ct_questions.CT_Practices";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvPractices.DataSource = dt;
                    lvPractices.DataBind();
                }
            }
        }
    }

    protected void getCountAllQuestions()
    {
        int conceptCount=0;
        try
        {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {
                using (SqlCommand cmdChildConceptCount = new SqlCommand())
                {
                    cmdChildConceptCount.CommandText = "select COUNT (DISTINCT QuestionID) from ct_questions.CT_Questions";


                    cmdChildConceptCount.Connection = conChild;
                    conChild.Open();
                    conceptCount = (int)cmdChildConceptCount.ExecuteScalar();
                    questionCounter.Text=conceptCount.ToString();
                    conChild.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }

    }

    protected void ItemBoundConcept(object sender, RepeaterItemEventArgs e)
    {
        String lvConceptId = (e.Item.FindControl("lvConceptId") as HiddenField).Value;
        int conceptCount=0;
        Label conceptCounterLabel = (Label)e.Item.FindControl("conceptCounter");

        try
        {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {
                using (SqlCommand cmdChildConceptCount = new SqlCommand())
                {
                    cmdChildConceptCount.CommandText = "select COUNT(DISTINCT QuestionID) from ct_questions.CT_QuestionConcept WHERE ConceptID = @lvConceptId";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@lvConceptId";
                    param.Value = lvConceptId;
                    cmdChildConceptCount.Parameters.Add(param);

                    cmdChildConceptCount.Connection = conChild;
                    conChild.Open();
                    conceptCount = (int)cmdChildConceptCount.ExecuteScalar();
                    conceptCounterLabel.Text="[ "+conceptCount.ToString()+" ]";
                    conChild.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }

    }

    protected void ItemBoundHabit(object sender, RepeaterItemEventArgs e)
    {
        String lvHabitId = (e.Item.FindControl("lvHabitId") as HiddenField).Value;
        int habitCount=0;
        Label habitCounterLabel = (Label)e.Item.FindControl("habitCounter");

        try
        {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {
                using (SqlCommand cmdChildHabitCount = new SqlCommand())
                {
                    cmdChildHabitCount.CommandText = "select COUNT(DISTINCT QuestionID) from ct_questions.CT_QuestionHabit WHERE HabitID = @lvHabitId";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@lvHabitId";
                    param.Value = lvHabitId;
                    cmdChildHabitCount.Parameters.Add(param);

                    cmdChildHabitCount.Connection = conChild;
                    conChild.Open();
                    habitCount = (int)cmdChildHabitCount.ExecuteScalar();
                    habitCounterLabel.Text="[ "+habitCount.ToString()+" ]";
                    conChild.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }

    }

    protected void ItemBoundPractice(object sender, RepeaterItemEventArgs e)
    {
        String lvPracticeId = (e.Item.FindControl("lvPracticeId") as HiddenField).Value;
        int practiceCount=0;
        Label practiceCounterLabel = (Label)e.Item.FindControl("practiceCounter");

        try
        {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {
                using (SqlCommand cmdChildPracticeCount = new SqlCommand())
                {
                    cmdChildPracticeCount.CommandText = "select COUNT(DISTINCT QuestionID) from ct_questions.CT_QuestionPractice WHERE PracticeID = @lvPracticeId";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@lvPracticeId";
                    param.Value = lvPracticeId;
                    cmdChildPracticeCount.Parameters.Add(param);

                    cmdChildPracticeCount.Connection = conChild;
                    conChild.Open();
                    practiceCount = (int)cmdChildPracticeCount.ExecuteScalar();
                    practiceCounterLabel.Text="[ "+practiceCount.ToString()+" ]";
                    conChild.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }

    }

    protected void rateQues_Click(object sender, CommandEventArgs e)
    {   Session["questionID"] = e.CommandArgument.ToString();
        Response.Redirect("CTRateQuestion.aspx");
    }

    protected void selectConceptIntoLabel_Click(object sender, CommandEventArgs e)
    {       
        String selectedValues = e.CommandArgument.ToString();
        String[] selectedValuesArr = selectedValues.Split(',');
        selectedCHPName.Text="Selected: "+selectedValuesArr[0];
        selectorCHP.Text="Now select the question type";
        selectedConceptID.Value=selectedValuesArr[1];

        CHPDiv.Visible=false;
        SMFDiv.Visible=true;
        
    }

    protected void selectHabitIntoLabel_Click(object sender, CommandEventArgs e)
    {       
        String selectedValues = e.CommandArgument.ToString();
        String[] selectedValuesArr = selectedValues.Split(',');
        selectedCHPName.Text="Selected: "+selectedValuesArr[0];
        selectedHabitID.Value=selectedValuesArr[1];

        CHPDiv.Visible=false;
        SMFDiv.Visible=true;

    }
    
    protected void selectPracticeIntoLabel_Click(object sender, CommandEventArgs e)
    {       
        String selectedValues = e.CommandArgument.ToString();
        String[] selectedValuesArr = selectedValues.Split(',');
        selectedCHPName.Text="Selected: "+selectedValuesArr[0];
        selectedPracticeID.Value=selectedValuesArr[1];

        CHPDiv.Visible=false;
        SMFDiv.Visible=true;
        
    }

    protected void goToSingleAnswer(object sender, EventArgs e)
    {
        String link = "CTSingleAnswer.aspx?lvConceptId="+selectedConceptID.Value+"&lvHabitId="+selectedHabitID.Value+"&lvPracticeId="+selectedPracticeID.Value;
        Response.Redirect(link);
    }

    protected void goToMultipleChoice(object sender, EventArgs e)
    {
        String link = "CTMultipleChoice.aspx?lvConceptId="+selectedConceptID.Value+"&lvHabitId="+selectedHabitID.Value+"&lvPracticeId="+selectedPracticeID.Value;
        Response.Redirect(link);
    }

    protected void goToFileType(object sender, EventArgs e)
    {
        String link = "CTFileType.aspx?lvConceptId="+selectedConceptID.Value+"&lvHabitId="+selectedHabitID.Value+"&lvPracticeId="+selectedPracticeID.Value;
        Response.Redirect(link);
    }

    protected void logout(object sender, EventArgs e)
    {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Response.Redirect("Default.aspx");
    }

    protected void goToAddNewQuestion(object sender, EventArgs e)
    {
        Response.Redirect("CTAddNewQuestion.aspx");
    }

    protected void goToViewAllQuestions(object sender, EventArgs e)
    {
        Response.Redirect("CTViewAllQuestions.aspx");
    }

    protected void goToViewOpenEQuestions(object sender, EventArgs e)
    {
        Response.Redirect("CTViewOpenEQuestions.aspx");
    }

    protected void goToViewCloseEQuestions(object sender, EventArgs e)
    {
        Response.Redirect("CTViewCloseEQuestions.aspx");
    }

    protected void addNewUser(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminAddNewUser.aspx");
    }

    protected void modifySchool(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminModifySchool.aspx");
    }

    protected void modifyHabit(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminModifyHabit.aspx");
    }

    protected void modifyConcept(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminModifyConcept.aspx");
    }

    protected void modifyPractice(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminModifyPractices.aspx");
    }

    protected void deleteUser(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminDeleteUser.aspx");
    }

    protected void categorySA(object sender, EventArgs e)
    {
        Response.Redirect("CTSingleAnswer.aspx");
    }

    protected void reloadSelection(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminLanding.aspx");
    }
    

    
    
    


}