﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Data;

using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;

using System.Net;
using System.Web.Script.Serialization;


using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Configuration;

public partial class AddNewUser : System.Web.UI.Page
{
    String conOLDBStr = ConfigurationManager.ConnectionStrings["techfitConnectionString"].ConnectionString.ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
             // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role!=1){
                Response.Redirect("Default.aspx");
            }
            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
        }
        catch (Exception exception)
        {
            Response.Redirect("Default.aspx");
        }

    }

    protected void logout(object sender, EventArgs e)
    {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Response.Redirect("Default.aspx");
    }
    
    protected void btnAddNewConcept_Click(object sender, EventArgs e)
    {

        string sql = "";
        lblErr.Text = "";

        // Set up a regular expression to filter out invalid name characters.
        Regex myFilter = new Regex("[0-9a-zA-Z-_]");

        String conceptName = txtConceptName.Text;
        
        if (conceptName == "")
        {
            lblResult.Text = "Concept name is required.";
            txtConceptName.Focus();
            return;
        }

        myFilter = new Regex("[0-9a-zA-Z'-_!]*");

        // Add Concept in DB
        OleDbConnection db = new OleDbConnection();
        db.ConnectionString = conOLDBStr;

        try
        {
            
            db.Open();
            OleDbCommand cmdContributors = db.CreateCommand();
            cmdContributors.CommandText = "insert into ct_questions.CT_Concepts values (?)";
            cmdContributors.Parameters.AddWithValue("@conceptName", conceptName);
            
            cmdContributors.ExecuteNonQuery();

            StringBuilder sb = new StringBuilder();
            String message = "Concept added!";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "');window.open('CTAdminModifyConcept.aspx','_self');");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);

        }
        
        catch (Exception err)
        {
            lblResult.Text = "ERROR: There was a problem - " + err.Message + err.StackTrace;
        }
        finally
        {
            db.Close();

        }


    }
    protected void goBack(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminLanding.aspx");
    }

  private void ClearAll()
        {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
        }

    // Helper method to filter the user's input
    private string toSQL(string stringValue)
    {
        string temp = stringValue.Replace("'", "''");
        temp = temp.Replace("<", "");
        temp = temp.Replace(">", "");
        temp = temp.Replace(";", " ");
        temp = temp.Replace(" OR ", " ");

        return "'" + temp + "'";
    }

    protected void SqlDataSource1_Selecting(object sender, SqlDataSourceSelectingEventArgs e)
    {

    }

    protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
    {

    }
}