﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Data;

using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;

using System.Net;
using System.Web.Script.Serialization;
using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;
using System.IO;
using System.Collections.Generic;

public partial class CTQuestionsCB : System.Web.UI.Page
{
    String conStr = ConfigurationManager.ConnectionStrings["techfitConnectionStringNonODB"].ConnectionString.ToString();
    String conOLDBStr = ConfigurationManager.ConnectionStrings["techfitConnectionString"].ConnectionString.ToString();

    protected void Page_Load(object sender, EventArgs e)
    {

        try
        {
            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
            if (!this.IsPostBack)
            {
                this.BindRepeaterConcepts();
                this.BindRepeaterHabits();
                this.BindRepeaterPractices();
                this.BindRepeaterViewAllFileTypeQuestions();
            }
            // Adapt page depending on role
            int role = Convert.ToInt32(Session["Role"].ToString());
            //Admin
            if (role == 1)
            {
                for (int i = 0; i <= rptAccordian.Items.Count - 1; i++)
                {
                    Button deleteBtn = (Button)rptAccordian.Items[i].FindControl("deleteQuestion");
                    deleteBtn.Visible = true;
                }

            }
            //Contributor
            else if (role == 2)
            {


            }
            //Expert
            else if (role == 3)
            {
               for (int i = 0; i <= rptAccordian.Items.Count - 1; i++)
                {
                    Button deleteBtn = (Button)rptAccordian.Items[i].FindControl("deleteQuestion");
                    deleteBtn.Visible = false;
                }
                addQuestionDiv.Visible=false;
            }
            //Viewer
            else if (role == 4)
            {
               for (int i = 0; i <= rptAccordian.Items.Count - 1; i++)
                {
                    Button rateBtn = (Button)rptAccordian.Items[i].FindControl("rateQuestion");
                    Button deleteBtn = (Button)rptAccordian.Items[i].FindControl("deleteQuestion");
                    rateBtn.Visible = false;
                    deleteBtn.Visible = false;
                }
                addQuestionDiv.Visible=false;
            }
        }
        catch (Exception exception)
        {
            lblErr.Text = "An error occured. Please try again later!"+ exception.Message;
            //lblErr.Text = exception.Message;
           // Response.Redirect("Default.aspx");

        }
        
    }

    public static String GetTimestamp(DateTime value)
    {
        return value.ToString("yyyyMMddHHmmssffff");
    }

    protected void upload(object sender, EventArgs e)
    {
        
        if (FileUpload1.HasFile)
        {
            //string fileName = Path.GetFileName(FileUpload1.PostedFile.FileName);
            //FileUpload1.PostedFile.SaveAs(Server.MapPath("~/Data/" + fileName));
            String timeStamp = GetTimestamp(DateTime.Now);
            timeStamp = timeStamp + ".jpg";
            FileUpload1.PostedFile.SaveAs(Server.MapPath("~/Data/CT/Images/" + timeStamp));
            //FileUpload1.PostedFile.SaveAs(Server.MapPath("~/CTQuestions/") + fileName);
            //Response.Redirect(Request.Url.AbsoluteUri);
            fileTypeName.Value = "../Data/CT/Images/" + timeStamp; 
            uploaded.Text = "File uploaded!";
        }
    }

    protected void rateQues_Click(object sender, CommandEventArgs e)
    {
        Session["questionID"] = e.CommandArgument.ToString();
        Session["questionType"] = "3";
        
        Response.Redirect("CTRateQuestion.aspx");
    }

    protected void deleteQues_Click(object sender, CommandEventArgs e)
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    cmd.CommandText = "delete from ct_questions.CT_Questions WHERE QuestionID = @QuesID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = e.CommandArgument.ToString();
                    cmd.Parameters.Add(param);
                    cmd.Connection = con;
                    con.Open();
                    rptAccordian.DataSource = cmd.ExecuteReader();
                    rptAccordian.DataBind();
                    con.Close();
                }
            }
            Response.Redirect(Page.Request.RawUrl,false);

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }

    private void BindRepeaterConcepts()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT ConceptID, ConceptName FROM ct_questions.CT_Concepts";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvConcepts.DataSource = dt;
                    lvConcepts.DataBind();
                }
            }
        }
    }

    private void BindRepeaterHabits()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT HabitId, HabitName FROM ct_questions.CT_Habits";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvHabits.DataSource = dt;
                    lvHabits.DataBind();
                }
            }
        }
    }

    private void BindRepeaterPractices()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT PracticeId, PracticeName FROM ct_questions.CT_Practices";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvPractices.DataSource = dt;
                    lvPractices.DataBind();
                }
            }
        }
    }

    private void BindRepeaterViewAllFileTypeQuestions()
    {
        String lvConceptId = null;
        String lvHabitId = null;
        String lvPracticeId = null;
        try
        {
            lvConceptId = Request.QueryString["lvConceptId"];
            lvHabitId = Request.QueryString["lvHabitId"];
            lvPracticeId = Request.QueryString["lvPracticeId"];

            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    if(lvConceptId!="")
                    {
                        cmd.CommandText = "select S.QFilename, S.QAnswer, Q.Source, Q.ContributorID, S.Notes, Q.DifficultyLevel, S.QuestionID, ROUND(AVG(Cast(QC.Complexity as Float)), 1) as AvgConceptComplexity, ROUND(AVG(Cast(QH.Complexity as Float)), 1) as AvgHabitComplexity, ROUND(AVG(Cast(QP.Complexity as Float)), 1) as AvgPracticeComplexity from ct_questions.CT_Question_File S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID WHERE QC.ConceptID=@ConceptID GROUP BY S.QFilename, S.QAnswer, S.Notes, Q.DifficultyLevel, S.QuestionID, Q.ContributorID, Q.Source";
                        SqlParameter param = new SqlParameter();
                        param.ParameterName = "@ConceptID";
                        param.Value = lvConceptId;
                        cmd.Parameters.Add(param);
                    }
                    else if(lvHabitId!="")
                    {
                        cmd.CommandText = "select S.QFilename, S.QAnswer, Q.Source, Q.ContributorID, S.Notes, Q.DifficultyLevel, S.QuestionID, ROUND(AVG(Cast(QC.Complexity as Float)), 1) as AvgConceptComplexity, ROUND(AVG(Cast(QH.Complexity as Float)), 1) as AvgHabitComplexity, ROUND(AVG(Cast(QP.Complexity as Float)), 1) as AvgPracticeComplexity from ct_questions.CT_Question_File S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID WHERE QH.HabitID=@HabitID GROUP BY S.QFilename, S.QAnswer, S.Notes, Q.DifficultyLevel, S.QuestionID, Q.ContributorID, Q.Source";
                        SqlParameter param = new SqlParameter();
                        param.ParameterName = "@HabitID";
                        param.Value = lvHabitId;
                        cmd.Parameters.Add(param);
                    }
                    else if(lvPracticeId!="")
                    {
                        cmd.CommandText = "select S.QFilename, S.QAnswer, Q.Source, Q.ContributorID, S.Notes, Q.DifficultyLevel, S.QuestionID, ROUND(AVG(Cast(QC.Complexity as Float)), 1) as AvgConceptComplexity, ROUND(AVG(Cast(QH.Complexity as Float)), 1) as AvgHabitComplexity, ROUND(AVG(Cast(QP.Complexity as Float)), 1) as AvgPracticeComplexity from ct_questions.CT_Question_File S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID WHERE QP.PracticeID=@PracticeID GROUP BY S.QFilename, S.QAnswer, S.Notes, Q.DifficultyLevel, S.QuestionID, Q.ContributorID, Q.Source";
                        SqlParameter param = new SqlParameter();
                        param.ParameterName = "@PracticeID";
                        param.Value = lvPracticeId;
                        cmd.Parameters.Add(param);
                    }
                    cmd.Connection = con;
                    con.Open();
                    rptAccordian.DataSource = cmd.ExecuteReader();
                    rptAccordian.DataBind();
                    con.Close();
                    rowCountQuestions.Text = "# of Questions: "+rptAccordian.Items.Count;
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.Message;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.StackTrace;
        }
    }

    protected void ItemBound(object sender, RepeaterItemEventArgs e)
    {
        String hfQuestionID = (e.Item.FindControl("hfQuestionID") as HiddenField).Value;
        String hfContributorID = (e.Item.FindControl("hfContributorID") as HiddenField).Value;
        Button deleteQuestion = (Button)e.Item.FindControl("deleteQuestion");
        Label contNameLabel = (Label)e.Item.FindControl("contrName");
        String contName = null;

        if (hfContributorID.Equals(Session["ContributorID"].ToString()))
        {
            deleteQuestion.Visible = true;
        }

        Repeater childRepeaterForConcept = (Repeater)e.Item.FindControl("rptAccordianConcept");
        Repeater childRepeaterForHabit = (Repeater)e.Item.FindControl("rptAccordianHabit");
        Repeater childRepeaterForPractice = (Repeater)e.Item.FindControl("rptAccordianPractice");

        try
        {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {
                using (SqlCommand cmdChildConcept = new SqlCommand())
                {
                    cmdChildConcept.CommandText = "select C.ConceptName, ROUND(AVG(Cast(QC.Complexity as Float)), 1) as AvgConceptComplexity from ct_questions.CT_QuestionConcept QC LEFT JOIN ct_questions.CT_Concepts C ON QC.ConceptID=C.ConceptID WHERE QuestionID = @QuesID GROUP BY C.ConceptName, QC.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildConcept.Parameters.Add(param);

                    cmdChildConcept.Connection = conChild;
                    conChild.Open();
                    childRepeaterForConcept.DataSource = cmdChildConcept.ExecuteReader();
                    childRepeaterForConcept.DataBind();
                    conChild.Close();
                }
                using (SqlCommand cmdChildHabit = new SqlCommand())
                {
                    cmdChildHabit.CommandText = "select H.HabitName, ROUND(AVG(Cast(QH.Complexity as Float)), 1) as AvgHabitComplexity from ct_questions.CT_QuestionHabit QH LEFT JOIN ct_questions.CT_Habits H ON QH.HabitID=H.HabitID WHERE QuestionID = @QuesID GROUP BY H.HabitName, QH.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildHabit.Parameters.Add(param);

                    cmdChildHabit.Connection = conChild;
                    conChild.Open();
                    childRepeaterForHabit.DataSource = cmdChildHabit.ExecuteReader();
                    childRepeaterForHabit.DataBind();
                    conChild.Close();
                }
                using (SqlCommand cmdChildPractice = new SqlCommand())
                {
                    cmdChildPractice.CommandText = "select P.PracticeName, ROUND(AVG(Cast(QP.Complexity as Float)), 1) as AvgPracticeComplexity from ct_questions.CT_QuestionPractice QP LEFT JOIN ct_questions.CT_Practices P ON QP.PracticeID=P.PracticeID WHERE QuestionID = @QuesID GROUP BY P.PracticeName, QP.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildPractice.Parameters.Add(param);

                    cmdChildPractice.Connection = conChild;
                    conChild.Open();
                    childRepeaterForPractice.DataSource = cmdChildPractice.ExecuteReader();
                    childRepeaterForPractice.DataBind();
                    conChild.Close();
                }
                using (SqlCommand cmdChildContName = new SqlCommand())
                {
                    cmdChildContName.CommandText = "select ContributorName from ct_questions.CT_Contributors WHERE ContributorID = @hfContributorID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@hfContributorID";
                    param.Value = hfContributorID;
                    cmdChildContName.Parameters.Add(param);

                    cmdChildContName.Connection = conChild;
                    conChild.Open();
                    contName = (string)cmdChildContName.ExecuteScalar();
                    contNameLabel.Text=contName;
                    conChild.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }

    }

    protected void logout(object sender, EventArgs e)
    {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Response.Redirect("Default.aspx");
    }

    protected void goBack(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminLanding.aspx");
    }

    protected void textualInsertButton_Click(object sender, EventArgs e)
    {
        OleDbConnection db = null;
        int qID = 0, rated=0;

        try
        {
            String contIdStr = Session["ContributorID"].ToString();
            String fileTypeQuestionTypeStr = fileTypeQuestionType.SelectedValue;
            String fileTypeNameStr = fileTypeName.Value;
            String fileTypeInsertQAnswerStr = fileTypeInsertQAnswer.Text;
            String fileTypeInsertQNotesStr = fileTypeInsertQNotes.Text;
            String fileTypeInsertQSourceStr = fileTypeInsertQSource.Text;
            String fileTypeDifficultyLevelStr = fileTypeDifficultyLevel.SelectedValue;


            // Validation
            Regex myFilter = new Regex("[0-9a-zA-Z-_,@;]");

            if (fileTypeQuestionType.SelectedIndex == 0)
            {
                lblErr.Text = "Select a valid question type!";
                fileTypeQuestionType.Focus();
                return;
            }

            if (fileTypeNameStr == "")
            {
                lblErr.Text = "Please upload a file!";
                return;
            }

            if (fileTypeDifficultyLevel.SelectedIndex == 0)
            {
                lblErr.Text = "Select a valid difficulty level!";
                fileTypeDifficultyLevel.Focus();
                return;
            }

            if (fileTypeInsertQAnswerStr == "")
            {
                lblErr.Text = "Answer is required!";
                fileTypeInsertQAnswer.Focus();
                return;
            }

            if (!myFilter.IsMatch(fileTypeInsertQAnswerStr))
            {
                lblErr.Text = "The answer you entered is invalid!";
                return;
            }

            if (fileTypeInsertQNotesStr == "")
            {
                lblErr.Text = "Notes is required!";
                fileTypeInsertQNotes.Focus();
                return;
            }

            foreach (RepeaterItem item in lvConcepts.Items)
            {
                DropDownList lvConceptDropdown = (DropDownList)item.FindControl("lvConceptDropdown");
                if (Convert.ToInt32(lvConceptDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            foreach (RepeaterItem item in lvHabits.Items)
            {
                DropDownList lvHabitsDropdown = (DropDownList)item.FindControl("lvHabitsDropdown");
                if (Convert.ToInt32(lvHabitsDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            foreach (RepeaterItem item in lvPractices.Items)
            {
                DropDownList lvPracticesDropdown = (DropDownList)item.FindControl("lvPracticesDropdown");
                if (Convert.ToInt32(lvPracticesDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            if (rated == 0)
            {
                lblErr.Text = "You must rate at least one Concept, Habit or Practice!";
                return;
            }

            db = new OleDbConnection();
            db.ConnectionString = conOLDBStr;
            db.Open();

            // For CT_Questions
            OleDbCommand cmdQuestions = db.CreateCommand();
            cmdQuestions.CommandText = "insert into ct_questions.CT_Questions values ('FT', ?, ?, ?, ?)";
            cmdQuestions.Parameters.AddWithValue("@fileTypeDifficultyLevelStr", fileTypeDifficultyLevelStr);
            cmdQuestions.Parameters.AddWithValue("@contIdStr", contIdStr);
            cmdQuestions.Parameters.AddWithValue("@fileTypeInsertQNotesStr", fileTypeInsertQNotesStr);
            cmdQuestions.Parameters.AddWithValue("@fileTypeInsertQSourceStr", fileTypeInsertQSourceStr);
            cmdQuestions.ExecuteNonQuery();

            String queryQID = "SELECT @@IDENTITY";
            OleDbCommand cmdQID = new OleDbCommand(queryQID, db);
            qID = Convert.ToInt32(cmdQID.ExecuteScalar());



            // For CT_Question_File
            OleDbCommand cmdQuestionsMC = db.CreateCommand();
            cmdQuestionsMC.CommandText = "insert into ct_questions.CT_Question_File values (?, ?, ?, ?, ?)";
            cmdQuestionsMC.Parameters.AddWithValue("@qID", qID);
            cmdQuestionsMC.Parameters.AddWithValue("@fileTypeNameStr", fileTypeNameStr);
            cmdQuestionsMC.Parameters.AddWithValue("@fileTypeInsertQAnswerStr", fileTypeInsertQAnswerStr);
            cmdQuestionsMC.Parameters.AddWithValue("@fileTypeInsertQNotesStr", fileTypeInsertQNotesStr);
            cmdQuestionsMC.Parameters.AddWithValue("@fileTypeQuestionTypeStr", fileTypeQuestionTypeStr);
            cmdQuestionsMC.ExecuteNonQuery();


            // For Concepts

            foreach (RepeaterItem item in lvConcepts.Items)
            {
                DropDownList lvConceptDropdown = (DropDownList)item.FindControl("lvConceptDropdown");
                HiddenField lvConceptId = (HiddenField)item.FindControl("lvConceptId");
                String conceptId = lvConceptId.Value;

                if (Convert.ToInt32(lvConceptDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionConcept = db.CreateCommand();
                    cmdQuestionConcept.CommandText = "insert into ct_questions.CT_QuestionConcept values (?, ?, ?, ?)";
                    cmdQuestionConcept.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionConcept.Parameters.AddWithValue("@conceptID", conceptId);
                    cmdQuestionConcept.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionConcept.Parameters.AddWithValue("@textualComplexityStr", Convert.ToInt32(lvConceptDropdown.SelectedValue));
                    cmdQuestionConcept.ExecuteNonQuery();
                }


            }



            // For Habits

            foreach (RepeaterItem item in lvHabits.Items)
            {
                DropDownList lvHabitsDropdown = (DropDownList)item.FindControl("lvHabitsDropdown");
                HiddenField lvHabitId = (HiddenField)item.FindControl("lvHabitId");
                String habitId = lvHabitId.Value;

                if (Convert.ToInt32(lvHabitsDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionHabit = db.CreateCommand();
                    cmdQuestionHabit.CommandText = "insert into ct_questions.CT_QuestionHabit values (?, ?, ?, ?)";
                    cmdQuestionHabit.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionHabit.Parameters.AddWithValue("@habitID", habitId);
                    cmdQuestionHabit.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionHabit.Parameters.AddWithValue("@textualComplexityStr", Convert.ToInt32(lvHabitsDropdown.SelectedValue));
                    cmdQuestionHabit.ExecuteNonQuery();
                }


            }

            // For Practices

            foreach (RepeaterItem item in lvPractices.Items)
            {
                DropDownList lvPracticesDropdown = (DropDownList)item.FindControl("lvPracticesDropdown");
                HiddenField lvPracticeId = (HiddenField)item.FindControl("lvPracticeId");
                String practiceId = lvPracticeId.Value;

                if (Convert.ToInt32(lvPracticesDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionPractice = db.CreateCommand();
                    cmdQuestionPractice.CommandText = "insert into ct_questions.CT_QuestionPractice values (?, ?, ?, ?)";
                    cmdQuestionPractice.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionPractice.Parameters.AddWithValue("@practiceID", practiceId);
                    cmdQuestionPractice.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionPractice.Parameters.AddWithValue("@textualComplexityStr", Convert.ToInt32(lvPracticesDropdown.SelectedValue));
                    cmdQuestionPractice.ExecuteNonQuery();
                }


            }

            db.Close();
            StringBuilder sb = new StringBuilder();
            String message="Question added!";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "');location.reload();");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again!";
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.Message;
        }
    }
}