﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Data.OleDb;
using System.Net.Mail;

using System.Collections.Generic;
using System.Linq;
using System.Collections;
using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;
using System.Net;
using System.Web.Script.Serialization;
using System.Web.UI.WebControls.WebParts;
using System.Drawing;

public partial class CTForgotPassword : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        Page.MaintainScrollPositionOnPostBack = true;
        string msg = Request.QueryString["err"];
        lblErr.Text = msg;

        string msg2 = Request.QueryString["msg"];
        lblResult.Text = msg2;

        string msg3 = Request.QueryString["logout"];

        if (msg3 == "true")
        {
            ClearAll();
        }
    }
    
    protected void btnResetPassword_Click(object sender, EventArgs e)
    {
		string sql = "";
        lblErr.Text = "";

        // Set up a regular expression to filter out invalid name characters.
        Regex myFilter = new Regex("[0-9a-zA-Z-_]");

        string user = txtUsername.Text;

        if (user == "")
        {
            lblResult.Text = "ERROR: User name is required.";
            txtUsername.Focus();
            return;
        }


        if (!myFilter.IsMatch(user))
        {
            lblResult.Text = "The username you entered has an invalid character, so the request cannot be processed.";
            return;
        }

        // Look for user in DB
        OleDbConnection db = new OleDbConnection();
        db.ConnectionString = Configuration.ConnectionString;
// OTP
        try
        {  
            db.Open();

            sql = "SELECT * FROM ct_questions.CT_Contributors WHERE [Username] = " + toSQL(user);

            OleDbCommand cmd = new OleDbCommand(sql, db);
            OleDbDataReader rdr = cmd.ExecuteReader();

            // If a match is found, assign the session variable to signify authorized.
            if (rdr.Read() == true)
            {
                String userId = rdr["ContributorID"].ToString();
				//Response.Redirect("RevLogin.aspx?msg=" + rdr["FirstName"].ToString());
                String name = rdr["FirstName"].ToString();
                String email = rdr["Email"].ToString();
                //For generating OTP
                    Random r = new Random();
                    String otp = r.Next(1000, 9999).ToString();
                    sql = "UPDATE ct_questions.CT_Contributors SET ForgotPasswordOTP = ? WHERE ContributorID = ?";
                    db = new OleDbConnection();
                    db.ConnectionString = Configuration.ConnectionString;
                    db.Open();
                    cmd = new OleDbCommand(sql, db);
                    cmd.Parameters.AddWithValue("ForgotPasswordOTP", otp);
                    cmd.Parameters.AddWithValue("UserID", userId);
                    cmd.ExecuteNonQuery();
                SendMail(name, email, otp, userId); 
                
            }
            else
            {
                ClearAll();
                Response.Redirect("Default.aspx?msg=" + user + ", your name is not recognized. Please contact the webmaster of this site.");
            }

            rdr.Close();
        }
        catch (Exception err)
        {
            lblResult.Text = "ERROR: There was a problem - " + err.Message + err.StackTrace;
        }
        finally
        {
            db.Close();
        }
    } 

    public void SendMail(String name, String email, String otp, String userId)
    {
        try
        {
            String passwordResetLink = "https://ecniisdev.ecn.purdue.edu/dev.techfit/CTAlternate/CTResetPassword.aspx?name="+name+"&id="+userId;
            // Email to person resetting password
            MailMessage requesterMail = new MailMessage();
            requesterMail.From = new MailAddress("techfit@purdue.edu");
            requesterMail.To.Add(email);
            requesterMail.Subject = "TECHFIT Forgot Password";
            requesterMail.Body = "Hi "+name
            +", we have received a forgot password request. \n"+"One-Time Password (OTP): "+otp+"\n The link for resetting your password is:\n"+passwordResetLink;

            SmtpClient requesterClient = new SmtpClient();            
            requesterClient.Send(requesterMail);

            StringBuilder sb = new StringBuilder();
            String message="Forgot password request sent! You will receive an email from the admin with a link to reset your password!";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "');window.open('Default.aspx','_self');");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
        }
        catch (Exception ex)
        {
            lblErr.Text = ex.ToString();
        }

    }


   private void ClearAll()
        {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
        }

    // Helper method to filter the user's input
    private string toSQL(string stringValue)
    {
        string temp = stringValue.Replace("'", "''");
        temp = temp.Replace("<", "");
        temp = temp.Replace(">", "");
        temp = temp.Replace(";", " ");
        temp = temp.Replace(" OR ", " ");

        return "'" + temp + "'";
    }
}