﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Data;

using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;

using System.Net;
using System.Web.Script.Serialization;


using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;

public partial class CTQuestionsCB : System.Web.UI.Page
{
    String conStr = ConfigurationManager.ConnectionStrings["techfitConnectionStringNonODB"].ConnectionString.ToString();
    String conOLDBStr = ConfigurationManager.ConnectionStrings["techfitConnectionString"].ConnectionString.ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
             // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role==3){
                Response.Redirect("Default.aspx");
            }
            Page.MaintainScrollPositionOnPostBack = true;
            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
            if (!this.IsPostBack)
            {
                this.BindRepeaterConcepts();
                this.BindRepeaterHabits();
                this.BindRepeaterPractices();
                this.BindRepeaterViewAllMultipleChoiceQuestions();
            }
            
            // Adapt page depending on role
            //Admin
            if (role == 1)
            {
                for (int i = 0; i <= rptAccordian.Items.Count - 1; i++)
                {
                    Button deleteBtn = (Button)rptAccordian.Items[i].FindControl("deleteQuestion");
                    deleteBtn.Visible = true;
                }
                addQuestionPanel.Visible=true;
            }
            //Teacher
            else if (role == 2)
            {
                for (int i = 0; i <= rptAccordian.Items.Count - 1; i++)
                {
                    //Button deleteBtn = (Button)rptAccordian.Items[i].FindControl("deleteQuestion");
                    //deleteBtn.Visible = true;
                }
                addQuestionPanel.Visible=true;
                for (int j = 0; j <= rptAccordian.Items.Count - 1; j++)
                {
                    Button deleteBtnMC = (Button)rptAccordian.Items[j].FindControl("markDeleteQuestion");
                    deleteBtnMC.Visible = true;
                }
            }
            //Expert
            else if (role == 4)
            {
               for (int i = 0; i <= rptAccordian.Items.Count - 1; i++)
                {
                    Button deleteBtn = (Button)rptAccordian.Items[i].FindControl("deleteQuestion");
                    deleteBtn.Visible = false;
                }
                addQuestionPanel.Visible=false;
            }
            //Contributor
            else if (role == 5)
            {
               for (int i = 0; i <= rptAccordian.Items.Count - 1; i++)
                {
                    Button deleteBtn = (Button)rptAccordian.Items[i].FindControl("deleteQuestion");
                    Button rateBtn = (Button)rptAccordian.Items[i].FindControl("rateQuestion");
                    rateBtn.Visible = false;
                    deleteBtn.Visible = false;
                }
                addQuestionPanel.Visible=true;
            }
            //Viewer
            else if (role == 6)
            {
               for (int i = 0; i <= rptAccordian.Items.Count - 1; i++)
                {
                    Button rateBtn = (Button)rptAccordian.Items[i].FindControl("rateQuestion");
                    Button deleteBtn = (Button)rptAccordian.Items[i].FindControl("deleteQuestion");
                    rateBtn.Visible = false;
                    deleteBtn.Visible = false;
                }
                addQuestionPanel.Visible=false;
            }
        }
        catch (Exception exception)
        {
            lblErr.Text = "An error occured. Please try again later!"+ exception.Message;
            //lblErr.Text = exception.Message;
            Response.Redirect("Default.aspx");

        }
        
    }

    protected void rateQues_Click(object sender, CommandEventArgs e)
    {
        Session["questionID"] = e.CommandArgument.ToString();
        Session["questionType"] = "2";
        
        Response.Redirect("CTRateQuestion.aspx");
    }

    protected void deleteQues_Click(object sender, CommandEventArgs e)
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    cmd.CommandText = "delete from ct_questions.CT_Questions WHERE QuestionID = @QuesID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = e.CommandArgument.ToString();
                    cmd.Parameters.Add(param);
                    cmd.Connection = con;
                    con.Open();
                    rptAccordian.DataSource = cmd.ExecuteReader();
                    rptAccordian.DataBind();
                    con.Close();
                    StringBuilder sb = new StringBuilder();
                    String message="Question deleted!";
                    sb.Append("<script type='text/javascript'>");
                    sb.Append("alert('" + message + "'); window.open('CTMultipleChoice.aspx','_self');");
                    sb.Append("</script>");
                    ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
                }
            }
            Response.Redirect(Page.Request.RawUrl,false);

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }

     protected void markDeleteQuesSA_Click(object sender, CommandEventArgs e)
    {
        try
        {
            Session["questionID"] = e.CommandArgument.ToString();
            Session["questionType"] = "1";
            Response.Redirect("CTMarkQuestionForDeletion.aspx");

        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }

    protected void markDeleteQuesMC_Click(object sender, CommandEventArgs e)
    {
        try
        {
            Session["questionID"] = e.CommandArgument.ToString();
            Session["questionType"] = "2";
            Response.Redirect("CTMarkQuestionForDeletion.aspx");

        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }

    private void BindRepeaterConcepts()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT ConceptID, ConceptName FROM ct_questions.CT_Concepts";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvConcepts.DataSource = dt;
                    lvConcepts.DataBind();
                }
            }
        }
    }

    private void BindRepeaterHabits()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT HabitId, HabitName FROM ct_questions.CT_Habits";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvHabits.DataSource = dt;
                    lvHabits.DataBind();
                }
            }
        }
    }

    private void BindRepeaterPractices()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT PracticeId, PracticeName FROM ct_questions.CT_Practices";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvPractices.DataSource = dt;
                    lvPractices.DataBind();
                }
            }
        }
    }

    private void BindRepeaterViewAllMultipleChoiceQuestions()
    {
        String lvConceptId = null;
        String lvHabitId = null;
        String lvPracticeId = null;
        try
        {
            lvConceptId = Request.QueryString["lvConceptId"];
            lvHabitId = Request.QueryString["lvHabitId"];
            lvPracticeId = Request.QueryString["lvPracticeId"];

            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    if(lvConceptId!="")
                    {
                        cmd.CommandText = "select S.QText, Q.ContributorID, S.QNbrChoices, S.QFilename, Q.Source, S.Choice1, S.Choice2, S.Choice3, S.Choice4, S.Choice5, S.Choice6, S.Choice7, S.Choice8, S.Choice9, S.Choice10, S.QAnswer, S.Notes, Q.GradeLevel, S.QuestionID, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_Question_MC S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID WHERE QC.ConceptID=@ConceptID GROUP BY S.QText, S.QNbrChoices, S.Choice1, S.Choice2, S.Choice3, S.Choice4, S.Choice5, S.Choice6, S.Choice7, S.Choice8, S.Choice9, S.Choice10, S.QAnswer, S.Notes, Q.GradeLevel, S.QuestionID, Q.ContributorID, S.QFilename, Q.Source";
                        SqlParameter param = new SqlParameter();
                        param.ParameterName = "@ConceptID";
                        param.Value = lvConceptId;
                        cmd.Parameters.Add(param);
                    }
                    else if(lvHabitId!="")
                    {
                        cmd.CommandText = "select S.QText, Q.ContributorID, S.QNbrChoices, S.QFilename, Q.Source, S.Choice1, S.Choice2, S.Choice3, S.Choice4, S.Choice5, S.Choice6, S.Choice7, S.Choice8, S.Choice9, S.Choice10, S.QAnswer, S.Notes, Q.GradeLevel, S.QuestionID, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_Question_MC S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID WHERE QH.HabitID=@HabitID GROUP BY S.QText, S.QNbrChoices, S.Choice1, S.Choice2, S.Choice3, S.Choice4, S.Choice5, S.Choice6, S.Choice7, S.Choice8, S.Choice9, S.Choice10, S.QAnswer, S.Notes, Q.GradeLevel, S.QuestionID, Q.ContributorID, S.QFilename, Q.Source";
                        SqlParameter param = new SqlParameter();
                        param.ParameterName = "@HabitID";
                        param.Value = lvHabitId;
                        cmd.Parameters.Add(param);
                    }
                    else if(lvPracticeId!="")
                    {
                        cmd.CommandText = "select S.QText, Q.ContributorID, S.QNbrChoices, S.QFilename, Q.Source, S.Choice1, S.Choice2, S.Choice3, S.Choice4, S.Choice5, S.Choice6, S.Choice7, S.Choice8, S.Choice9, S.Choice10, S.QAnswer, S.Notes, Q.GradeLevel, S.QuestionID, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_Question_MC S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID WHERE QP.PracticeID=@PracticeID GROUP BY S.QText, S.QNbrChoices, S.Choice1, S.Choice2, S.Choice3, S.Choice4, S.Choice5, S.Choice6, S.Choice7, S.Choice8, S.Choice9, S.Choice10, S.QAnswer, S.Notes, Q.GradeLevel, S.QuestionID, Q.ContributorID, S.QFilename, Q.Source";
                        SqlParameter param = new SqlParameter();
                        param.ParameterName = "@PracticeID";
                        param.Value = lvPracticeId;
                        cmd.Parameters.Add(param);
                    }
                    cmd.Connection = con;
                    con.Open();
                    rptAccordian.DataSource = cmd.ExecuteReader();
                    rptAccordian.DataBind();
                    con.Close();
                    rowCountQuestions.Text = "# of Questions: "+rptAccordian.Items.Count;
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }

    protected void ItemBound(object sender, RepeaterItemEventArgs e)
    {
        String hfQuestionID = (e.Item.FindControl("hfQuestionID") as HiddenField).Value;
        String hfContributorID = (e.Item.FindControl("hfContributorID") as HiddenField).Value;
        Button deleteQuestion = (Button)e.Item.FindControl("deleteQuestion");
        Label contNameLabel = (Label)e.Item.FindControl("contrName");
        String contName = null;

        if (hfContributorID.Equals(Session["ContributorID"].ToString()))
        {
            deleteQuestion.Visible = true;
        }

        Repeater childRepeaterForConcept = (Repeater)e.Item.FindControl("rptAccordianConcept");
        Repeater childRepeaterForHabit = (Repeater)e.Item.FindControl("rptAccordianHabit");
        Repeater childRepeaterForPractice = (Repeater)e.Item.FindControl("rptAccordianPractice");
        HtmlGenericControl mcHabitsDiv= e.Item.FindControl("mcHabitsDiv") as HtmlGenericControl;
        HtmlGenericControl mcPracticesDiv= e.Item.FindControl("mcPracticesDiv") as HtmlGenericControl;
        HtmlGenericControl mcConceptsDiv= e.Item.FindControl("mcConceptsDiv") as HtmlGenericControl;

        try
        {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {
                using (SqlCommand cmdChildConcept = new SqlCommand())
                {
                    cmdChildConcept.CommandText = "select C.ConceptName, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating from ct_questions.CT_QuestionConcept QC LEFT JOIN ct_questions.CT_Concepts C ON QC.ConceptID=C.ConceptID WHERE QuestionID = @QuesID GROUP BY C.ConceptName, QC.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildConcept.Parameters.Add(param);

                    cmdChildConcept.Connection = conChild;
                    conChild.Open();
                    childRepeaterForConcept.DataSource = cmdChildConcept.ExecuteReader();
                    childRepeaterForConcept.DataBind();
                    if(childRepeaterForConcept.Items.Count<1)
                    {
                        mcConceptsDiv.Visible = false;
                    }
                    conChild.Close();
                }
                using (SqlCommand cmdChildHabit = new SqlCommand())
                {
                    cmdChildHabit.CommandText = "select H.HabitName, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating from ct_questions.CT_QuestionHabit QH LEFT JOIN ct_questions.CT_Habits H ON QH.HabitID=H.HabitID WHERE QuestionID = @QuesID GROUP BY H.HabitName, QH.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildHabit.Parameters.Add(param);

                    cmdChildHabit.Connection = conChild;
                    conChild.Open();
                    childRepeaterForHabit.DataSource = cmdChildHabit.ExecuteReader();
                    childRepeaterForHabit.DataBind();
                    if(childRepeaterForHabit.Items.Count<1)
                    {
                        mcHabitsDiv.Visible = false;
                    }
                    conChild.Close();
                }
                using (SqlCommand cmdChildPractice = new SqlCommand())
                {
                    cmdChildPractice.CommandText = "select P.PracticeName, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_QuestionPractice QP LEFT JOIN ct_questions.CT_Practices P ON QP.PracticeID=P.PracticeID WHERE QuestionID = @QuesID GROUP BY P.PracticeName, QP.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildPractice.Parameters.Add(param);

                    cmdChildPractice.Connection = conChild;
                    conChild.Open();
                    childRepeaterForPractice.DataSource = cmdChildPractice.ExecuteReader();
                    childRepeaterForPractice.DataBind();
                    if(childRepeaterForPractice.Items.Count<1)
                    {
                        mcPracticesDiv.Visible = false;
                    }
                    conChild.Close();
                }
                using (SqlCommand cmdChildContName = new SqlCommand())
                {
                    cmdChildContName.CommandText = "select ContributorName from ct_questions.CT_Contributors WHERE ContributorID = @hfContributorID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@hfContributorID";
                    param.Value = hfContributorID;
                    cmdChildContName.Parameters.Add(param);

                    cmdChildContName.Connection = conChild;
                    conChild.Open();
                    contName = (string)cmdChildContName.ExecuteScalar();
                    contNameLabel.Text=contName;
                    conChild.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }

    }

    protected void logout(object sender, EventArgs e)
    {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Response.Redirect("Default.aspx");
    }

    protected void goToAddNewQuestion(object sender, EventArgs e)
    {
        Response.Redirect("CTAddNewQuestion.aspx");
    }

    protected void goBack(object sender, EventArgs e)
    {
        // Adapt page depending on rol  e
            int role = Convert.ToInt32(Session["Role"].ToString());
            //Admin
            if (role == 1)
            {
                Response.Redirect("CTAdminLanding.aspx");
            }
            else if(role==2){
                Response.Redirect("CTTeacherLanding.aspx");
            }
            else{
                Response.Redirect("CTLanding.aspx");
            }
        
    }

    protected void textualInsertButton_Click(object sender, EventArgs e)
    {
        OleDbConnection db = null;
        int qID = 0, rated=0;

        try
        {
            String contIdStr = Session["ContributorID"].ToString();
           
            String multipleChoiceInsertQuestionStr = multipleChoiceInsertQuestion.Text;
            String multipleChoiceNbrStr = multipleChoiceNbr.SelectedValue;
            String choice1 = null;
            String choice2 = null;
            String choice3 = null;
            String choice4 = null;
            String choice5 = null;
            String choice6 = null;
            String choice7 = null;
            String choice8 = null;
            String choice9 = null;
            String choice10 = null;
            String multipleChoiceInsertQAnswerStr = multipleChoiceInsertQAnswer.Text;
            String multipleChoiceInsertQNotesStr = multipleChoiceInsertQNotes.Text;
            String multipleChoiceInsertQSourceStr = multipleChoiceInsertQSource.Text;
            String multipleChoiceGradeLevelStr = multipleChoiceGradeLevel.SelectedValue;
            int i=0, remainingChoices=0, invalidChoces=0;

            // Validation
            Regex myFilter = new Regex("[0-9a-zA-Z-_,@;]");


            if (multipleChoiceInsertQuestionStr == "")
            {
                lblErr.Text = "Question is required!";
                multipleChoiceInsertQuestion.Focus();
                return;
            }

             if (!myFilter.IsMatch(multipleChoiceInsertQuestionStr))
            {
                lblErr.Text = "The question you entered is invalid!";
                return;
            }

            if (multipleChoiceNbr.SelectedIndex == 0)
            {
                lblErr.Text = "Select a valid choice number!";
                multipleChoiceNbr.Focus();
                return;
            }

            foreach (RepeaterItem item in mcqRepeat.Items)
            {
                TextBox txtName= (TextBox)item.FindControl("multipleChoice");
                if(txtName.Text=="")
                {
                    invalidChoces=1;
                }
            }

            if (invalidChoces == 1)
            {
                lblErr.Text = "Enter all the choices!";
                return;
            }

            if (multipleChoiceGradeLevel.SelectedIndex == 0)
            {
                lblErr.Text = "Select a valid difficulty level!";
                multipleChoiceGradeLevel.Focus();
                return;
            }

            if (multipleChoiceInsertQAnswerStr == "")
            {
                lblErr.Text = "Answer is required!";
                multipleChoiceInsertQAnswer.Focus();
                return;
            }

            if (!myFilter.IsMatch(multipleChoiceInsertQAnswerStr))
            {
                lblErr.Text = "The answer you entered is invalid!";
                return;
            }

            foreach (RepeaterItem item in lvConcepts.Items)
            {
                DropDownList lvConceptDropdown = (DropDownList)item.FindControl("lvConceptDropdown");
                if (Convert.ToInt32(lvConceptDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            foreach (RepeaterItem item in lvHabits.Items)
            {
                DropDownList lvHabitsDropdown = (DropDownList)item.FindControl("lvHabitsDropdown");
                if (Convert.ToInt32(lvHabitsDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            foreach (RepeaterItem item in lvPractices.Items)
            {
                DropDownList lvPracticesDropdown = (DropDownList)item.FindControl("lvPracticesDropdown");
                if (Convert.ToInt32(lvPracticesDropdown.SelectedValue) != 0)
                {
                    rated=1;
                }
            }
            if (rated == 0)
            {
                lblErr.Text = "You must rate at least one Concept, Habit or Practice!";
                return;
            }





            db = new OleDbConnection();
            db.ConnectionString = conOLDBStr;
            db.Open();

            // For CT_Questions
            OleDbCommand cmdQuestions = db.CreateCommand();
            cmdQuestions.CommandText = "insert into ct_questions.CT_Questions values ('MC', ?, ?, ?, ?)";
            cmdQuestions.Parameters.AddWithValue("@multipleChoiceGradeLevelStr", multipleChoiceGradeLevelStr);
            cmdQuestions.Parameters.AddWithValue("@contIdStr", contIdStr);
            cmdQuestions.Parameters.AddWithValue("@multipleChoiceInsertQNotesStr", multipleChoiceInsertQNotesStr);
            cmdQuestions.Parameters.AddWithValue("@multipleChoiceInsertQSourceStr", multipleChoiceInsertQSourceStr);          
            cmdQuestions.ExecuteNonQuery();

            String queryQID = "SELECT @@IDENTITY";
            OleDbCommand cmdQID = new OleDbCommand(queryQID, db);
            qID = Convert.ToInt32(cmdQID.ExecuteScalar());



            // For CT_Question_MC
            OleDbCommand cmdQuestionsMC = db.CreateCommand();
            cmdQuestionsMC.CommandText = "insert into ct_questions.CT_Question_MC values (?, ?, ?, ?, ?, ?, ?, ?, ?, ? ,?, ?, ?, ?, ?)";
            cmdQuestionsMC.Parameters.AddWithValue("@qID", qID);
            cmdQuestionsMC.Parameters.AddWithValue("@multipleChoiceInsertQuestionStr", multipleChoiceInsertQuestionStr);
            cmdQuestionsMC.Parameters.AddWithValue("@multipleChoiceNbrStr", multipleChoiceNbrStr);


            foreach (RepeaterItem item in mcqRepeat.Items)
            {
                TextBox txtName= (TextBox)item.FindControl("multipleChoice");
                if(txtName.Text!=null)
                {
                //do something with txtName.Text
                cmdQuestionsMC.Parameters.AddWithValue("@choice", txtName.Text);
                }
            }
            remainingChoices = 10-mcqRepeat.Items.Count;
            for(i=1;i<=remainingChoices;i++){
                cmdQuestionsMC.Parameters.AddWithValue("@choice", null);
            }
            cmdQuestionsMC.Parameters.AddWithValue("@multipleChoiceInsertQAnswerStr", multipleChoiceInsertQAnswerStr);
            cmdQuestionsMC.Parameters.AddWithValue("@multipleChoiceInsertQNotesStr", multipleChoiceInsertQNotesStr);
            cmdQuestionsMC.ExecuteNonQuery();


            // For Concepts

            foreach (RepeaterItem item in lvConcepts.Items)
            {
                DropDownList lvConceptDropdown = (DropDownList)item.FindControl("lvConceptDropdown");
                HiddenField lvConceptId = (HiddenField)item.FindControl("lvConceptId");
                String conceptId = lvConceptId.Value;

                if (Convert.ToInt32(lvConceptDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionConcept = db.CreateCommand();
                    cmdQuestionConcept.CommandText = "insert into ct_questions.CT_QuestionConcept values (?, ?, ?, ?)";
                    cmdQuestionConcept.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionConcept.Parameters.AddWithValue("@conceptID", conceptId);
                    cmdQuestionConcept.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionConcept.Parameters.AddWithValue("@textualAlignmentRatingStr", Convert.ToInt32(lvConceptDropdown.SelectedValue));
                    cmdQuestionConcept.ExecuteNonQuery();
                }


            }



            // For Habits

            foreach (RepeaterItem item in lvHabits.Items)
            {
                DropDownList lvHabitsDropdown = (DropDownList)item.FindControl("lvHabitsDropdown");
                HiddenField lvHabitId = (HiddenField)item.FindControl("lvHabitId");
                String habitId = lvHabitId.Value;

                if (Convert.ToInt32(lvHabitsDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionHabit = db.CreateCommand();
                    cmdQuestionHabit.CommandText = "insert into ct_questions.CT_QuestionHabit values (?, ?, ?, ?)";
                    cmdQuestionHabit.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionHabit.Parameters.AddWithValue("@habitID", habitId);
                    cmdQuestionHabit.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionHabit.Parameters.AddWithValue("@textualAlignmentRatingStr", Convert.ToInt32(lvHabitsDropdown.SelectedValue));
                    cmdQuestionHabit.ExecuteNonQuery();
                }


            }

            // For Practices

            foreach (RepeaterItem item in lvPractices.Items)
            {
                DropDownList lvPracticesDropdown = (DropDownList)item.FindControl("lvPracticesDropdown");
                HiddenField lvPracticeId = (HiddenField)item.FindControl("lvPracticeId");
                String practiceId = lvPracticeId.Value;

                if (Convert.ToInt32(lvPracticesDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionPractice = db.CreateCommand();
                    cmdQuestionPractice.CommandText = "insert into ct_questions.CT_QuestionPractice values (?, ?, ?, ?)";
                    cmdQuestionPractice.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionPractice.Parameters.AddWithValue("@practiceID", practiceId);
                    cmdQuestionPractice.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionPractice.Parameters.AddWithValue("@textualAlignmentRatingStr", Convert.ToInt32(lvPracticesDropdown.SelectedValue));
                    cmdQuestionPractice.ExecuteNonQuery();
                }


            }

            db.Close();
            StringBuilder sb = new StringBuilder();
            String message="Question added!";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "');location.reload();");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again!";
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.Message;
        }

    }


protected void multipleChoiceNbr_SelectedIndexChanged(object sender, EventArgs e)
{
    
    DataTable dt = new DataTable();
    dt.Columns.Add("TextBox");
    int count = Convert.ToInt32(multipleChoiceNbr.SelectedItem.Value);
    for (int i = 0; i < count; i++)
    {
        dt.Rows.Add("");
    }
    this.mcqRepeat.DataSource = dt;
    this.mcqRepeat.DataBind();
}


}