﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Data;

using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;

using System.Net;
using System.Web.Script.Serialization;


using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;

public partial class CTRateQuestion : System.Web.UI.Page
{
    String conStr = ConfigurationManager.ConnectionStrings["techfitConnectionStringNonODB"].ConnectionString.ToString();
    String conOLDBStr = ConfigurationManager.ConnectionStrings["techfitConnectionString"].ConnectionString.ToString();

    protected void Page_Load(object sender, EventArgs e)
    {

        try
        {
             // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role!=1 && role!=2 && role!=4){
                Response.Redirect("Default.aspx");
            }
            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();

            if (!this.IsPostBack)
            {
                //Saves the Previous page url in ViewState
                ViewState["PreviousPage"] = Request.UrlReferrer;
                this.BindRepeaterConcepts();
                this.BindRepeaterHabits();
                this.BindRepeaterPractices();
                this.ViewSelectedQuestion();

                int qType = Convert.ToInt32(Session["questionType"].ToString());
                //Single Answer Type
                if (qType==1)
                {
                    multipleChoiceDiv.Visible=false;
                    fileTypeDiv.Visible=false;
                }
                else if (qType==2)
                {
                    singleAnswerDiv.Visible=false;
                    fileTypeDiv.Visible=false;
                }
                else if (qType==3)
                {
                    singleAnswerDiv.Visible=false;
                    multipleChoiceDiv.Visible=false;
                }
            }
        }
        catch (Exception exception)
        {
            lblErr.Text = "An error occured. Please try again later!";
            //lblErr.Text = exception.Message;
           Response.Redirect("Default.aspx");
            
        }


    }

    
    private void ViewSelectedQuestion()
    {

        try
        {
            String questionID = (string)(Session["questionID"]);
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = questionID;
                    cmd.Parameters.Add(param);
                    cmd.Connection = con;
                    con.Open();
                    int qType = Convert.ToInt32(Session["questionType"].ToString());
                    //Single Answer Type
                    if (qType==1)
                    {
                        cmd.CommandText = "select S.QText, S.QAnswer, S.Notes, Q.GradeLevel, Q.Source, S.QuestionID, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_Question_SA S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID WHERE Q.QuestionID=@QuesID GROUP BY S.QText, S.QAnswer, S.Notes, Q.GradeLevel, Q.Source, S.QuestionID";
                        SqlDataReader reader = cmd.ExecuteReader();
                        while (reader.Read())
                        {
                            singleQuestionText.Text = String.Format("{0}", reader[0]);
                            singleQuestionAnswer.Text = String.Format("{0}", reader[1]);
                            singleQuestionNotes.Text = String.Format("{0}", reader[2]);
                            singleQuestionGradeLevel.Text = String.Format("{0}", reader[3]);
                            singleQuestionSource.Text = String.Format("{0}", reader[4]);
                        }
                    }
                    else if (qType==2)
                    {
                        cmd.CommandText = "select S.QText, S.QNbrChoices, S.Choice1, S.Choice2, S.Choice3, S.Choice4, S.Choice5, S.Choice6, S.Choice7, S.Choice8, S.Choice9, S.Choice10, S.QAnswer, S.Notes, Q.GradeLevel, Q.Source, S.QFileName, S.QuestionID, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_Question_MC S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID WHERE Q.QuestionID=@QuesID GROUP BY S.QText, S.QNbrChoices, S.Choice1, S.Choice2, S.Choice3, S.Choice4, S.Choice5, S.Choice6, S.Choice7, S.Choice8, S.Choice9, S.Choice10, S.QAnswer, S.Notes, Q.GradeLevel, Q.Source, S.QuestionID, S.QFileName";
                        SqlDataReader reader = cmd.ExecuteReader();
                        while (reader.Read())
                        {
                            multipleQuestionText.Text = String.Format("{0}", reader[0]);
                            multipleQuestionNbrChoices.Text = String.Format("{0}", reader[1]);
                            multipleQuestionChoice1.Text = String.Format("{0}", reader[2]);
                            multipleQuestionChoice2.Text = String.Format("{0}", reader[3]);
                            multipleQuestionChoice3.Text = String.Format("{0}", reader[4]);
                            multipleQuestionChoice4.Text = String.Format("{0}", reader[5]);
                            multipleQuestionChoice5.Text = String.Format("{0}", reader[6]);
                            multipleQuestionChoice6.Text = String.Format("{0}", reader[7]);
                            multipleQuestionChoice7.Text = String.Format("{0}", reader[8]);
                            multipleQuestionChoice8.Text = String.Format("{0}", reader[9]);
                            multipleQuestionChoice9.Text = String.Format("{0}", reader[10]);
                            multipleQuestionChoice10.Text = String.Format("{0}", reader[11]);
                            multipleQuestionAnswer.Text = String.Format("{0}", reader[12]);
                            multipleQuestionNotes.Text = String.Format("{0}", reader[13]);
                            multipleQuestionGradeLevel.Text = String.Format("{0}", reader[14]);
                            multipleQuestionSource.Text = String.Format("{0}", reader[15]);
                            mcFileName.Src = String.Format("{0}", reader[16]);
                        }
                    }
                    else if (qType==3)
                    {
                        cmd.CommandText = "select S.QFilename, S.QAnswer, S.Notes, Q.GradeLevel, Q.Source, S.QuestionID, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_Question_File S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID WHERE Q.QuestionID=@QuesID GROUP BY S.QFilename, S.QAnswer, S.Notes, Q.GradeLevel, Q.Source, S.QuestionID";
                        SqlDataReader reader = cmd.ExecuteReader();
                        while (reader.Read())
                        {
                            fileImage.ImageUrl = String.Format("{0}", reader[0]);
                            fileTypeAnswer.Text = String.Format("{0}", reader[1]);
                            fileTypeNotes.Text = String.Format("{0}", reader[2]);
                            fileTypeGradeLevel.Text = String.Format("{0}", reader[3]);
                            fileTypeSource.Text = String.Format("{0}", reader[4]);
                        }
                    }
                    
                    con.Close();
                }
            }
        }
        catch (System.Data.SqlClient.SqlException exception) 
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }




    private void BindRepeaterConcepts()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT ConceptID, ConceptName FROM ct_questions.CT_Concepts";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvConcepts.DataSource = dt;
                    lvConcepts.DataBind();
                }
            }
        }
    }

    private void BindRepeaterHabits()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT HabitId, HabitName FROM ct_questions.CT_Habits";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvHabits.DataSource = dt;
                    lvHabits.DataBind();
                }
            }
        }
    }

    private void BindRepeaterPractices()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT PracticeId, PracticeName FROM ct_questions.CT_Practices";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvPractices.DataSource = dt;
                    lvPractices.DataBind();
                }
            }
        }
    }

    

    protected void ItemBound(object sender, RepeaterItemEventArgs e)
        {
        string hfQuestionID = (e.Item.FindControl("hfQuestionID") as HiddenField).Value;

        Repeater childRepeaterForConcept = (Repeater)e.Item.FindControl("rptAccordianConcept");
        Repeater childRepeaterForHabit = (Repeater)e.Item.FindControl("rptAccordianHabit");
        Repeater childRepeaterForPractice = (Repeater)e.Item.FindControl("rptAccordianPractice");
        
        try
            {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {
                using (SqlCommand cmdChildConcept = new SqlCommand())
                {
                    cmdChildConcept.CommandText = "select C.ConceptName, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating from ct_questions.CT_QuestionConcept QC LEFT JOIN ct_questions.CT_Concepts C ON QC.ConceptID=C.ConceptID WHERE QuestionID = @QuesID GROUP BY C.ConceptName, QC.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildConcept.Parameters.Add(param);

                    cmdChildConcept.Connection = conChild; 
                    conChild.Open();
                    childRepeaterForConcept.DataSource = cmdChildConcept.ExecuteReader();
                    childRepeaterForConcept.DataBind();
                    conChild.Close();
                }
                using (SqlCommand cmdChildHabit = new SqlCommand())
                {
                    cmdChildHabit.CommandText = "select H.HabitName, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating from ct_questions.CT_QuestionHabit QH LEFT JOIN ct_questions.CT_Habits H ON QH.HabitID=H.HabitID WHERE QuestionID = @QuesID GROUP BY H.HabitName, QH.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildHabit.Parameters.Add(param);

                    cmdChildHabit.Connection = conChild; 
                    conChild.Open();
                    childRepeaterForHabit.DataSource = cmdChildHabit.ExecuteReader();
                    childRepeaterForHabit.DataBind();
                    conChild.Close();
                }
                using (SqlCommand cmdChildPractice = new SqlCommand())
                {
                    cmdChildPractice.CommandText = "select P.PracticeName, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_QuestionPractice QP LEFT JOIN ct_questions.CT_Practices P ON QP.PracticeID=P.PracticeID WHERE QuestionID = @QuesID GROUP BY P.PracticeName, QP.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildPractice.Parameters.Add(param);

                    cmdChildPractice.Connection = conChild; 
                    conChild.Open();
                    childRepeaterForPractice.DataSource = cmdChildPractice.ExecuteReader();
                    childRepeaterForPractice.DataBind();
                    conChild.Close();
                }
            }
            
            }
            catch (System.Data.SqlClient.SqlException exception)
            {

                lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
            }
            catch (Exception exception)
            {

                lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
            }
        
    }

    protected void logout(object sender, EventArgs e)
    {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Response.Redirect("Default.aspx");
    }
 
    protected void textualCancelButton_Click(object sender, EventArgs e)
    {
        Response.Redirect(ViewState["PreviousPage"].ToString());
        
    }

    protected void textualRateButton_Click(object sender, EventArgs e)
    {
        
        OleDbConnection db = null;
        int qID = Convert.ToInt32(Session["questionID"].ToString());

        try
        {
            String contIdStr = Session["ContributorID"].ToString();
      
            db = new OleDbConnection();
            db.ConnectionString = conOLDBStr;
            db.Open();

           
            // For Concepts

            foreach (RepeaterItem item in lvConcepts.Items)
            {
                DropDownList lvConceptDropdown = (DropDownList)item.FindControl("lvConceptDropdown");
                HiddenField lvConceptId = (HiddenField)item.FindControl("lvConceptId");
                String conceptId = lvConceptId.Value;

                if (Convert.ToInt32(lvConceptDropdown.SelectedValue) != 0)
                {
                    OleDbCommand cmdQuestionConcept = db.CreateCommand();
                    cmdQuestionConcept.CommandText = "insert into ct_questions.CT_QuestionConcept values (?, ?, ?, ?)";
                    cmdQuestionConcept.Parameters.AddWithValue("@qID", qID);
                    cmdQuestionConcept.Parameters.AddWithValue("@conceptID", conceptId);
                    cmdQuestionConcept.Parameters.AddWithValue("@contIdStr", contIdStr);
                    cmdQuestionConcept.Parameters.AddWithValue("@textualAlignmentRatingStr", Convert.ToInt32(lvConceptDropdown.SelectedValue));
                    cmdQuestionConcept.ExecuteNonQuery();
                }


            }


            
            // For Habits

            foreach (RepeaterItem item in lvHabits.Items)
                {
                    DropDownList lvHabitsDropdown = (DropDownList)item.FindControl("lvHabitsDropdown");
                    HiddenField lvHabitId = (HiddenField)item.FindControl("lvHabitId");
                    String habitId = lvHabitId.Value;

                    if (Convert.ToInt32(lvHabitsDropdown.SelectedValue) != 0)
                    {
                        OleDbCommand cmdQuestionHabit = db.CreateCommand();
                        cmdQuestionHabit.CommandText = "insert into ct_questions.CT_QuestionHabit values (?, ?, ?, ?)";
                        cmdQuestionHabit.Parameters.AddWithValue("@qID", qID);
                        cmdQuestionHabit.Parameters.AddWithValue("@habitID", habitId);
                        cmdQuestionHabit.Parameters.AddWithValue("@contIdStr", contIdStr);
                        cmdQuestionHabit.Parameters.AddWithValue("@textualAlignmentRatingStr", Convert.ToInt32(lvHabitsDropdown.SelectedValue));
                        cmdQuestionHabit.ExecuteNonQuery();
                    }


                }
          
            // For Practices

            foreach (RepeaterItem item in lvPractices.Items)
                {
                    DropDownList lvPracticesDropdown = (DropDownList)item.FindControl("lvPracticesDropdown");
                    HiddenField lvPracticeId = (HiddenField)item.FindControl("lvPracticeId");
                    String practiceId = lvPracticeId.Value;

                    if (Convert.ToInt32(lvPracticesDropdown.SelectedValue) != 0)
                    {
                        OleDbCommand cmdQuestionPractice = db.CreateCommand();
                        cmdQuestionPractice.CommandText = "insert into ct_questions.CT_QuestionPractice values (?, ?, ?, ?)";
                        cmdQuestionPractice.Parameters.AddWithValue("@qID", qID);
                        cmdQuestionPractice.Parameters.AddWithValue("@practiceID", practiceId);
                        cmdQuestionPractice.Parameters.AddWithValue("@contIdStr", contIdStr);
                        cmdQuestionPractice.Parameters.AddWithValue("@textualAlignmentRatingStr", Convert.ToInt32(lvPracticesDropdown.SelectedValue));
                        cmdQuestionPractice.ExecuteNonQuery();
                    }


                }

            db.Close();
            Response.Redirect(ViewState["PreviousPage"].ToString());
        }
        catch (OleDbException exception)
        {
            if (exception.ErrorCode == -2147217873)
            {
                //Violation of primary key. Handle Exception
                lblErr.Text = "You have already rated this question!";

            }
            else
            {
                lblErr.Text = "Error occured! Please try again!";
            }
            
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: "+exception.Message;
        }

    }


}