﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Data.OleDb;
using System.Net.Mail;

using System.Collections.Generic;
using System.Linq;
using System.Collections;
using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;
using System.Net;
using System.Web.Script.Serialization;
using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Web.Helpers;

public partial class CTResetPassword : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        Page.MaintainScrollPositionOnPostBack = true;
        string msg = Request.QueryString["err"];
        lblErr.Text = msg;

        string msg2 = Request.QueryString["msg"];
        lblResult.Text = msg2;

        string msg3 = Request.QueryString["logout"];

        if (msg3 == "true")
        {
            ClearAll();
        }
    }
    
   protected void btnResetPassword_Click(object sender, EventArgs e)
    {
		string sql = "";
        lblErr.Text = "";

        // Set up a regular expression to filter out invalid name characters.
        Regex myFilter = new Regex("[0-9a-zA-Z-_]");

        string userOtp = txtOtp.Text;
        string pass = txtPassword.Text;
        string passConfirm = txtPasswordConfirm.Text;

        if (userOtp == "")
        {
            lblResult.Text = "ERROR: OTP is required.";
            txtOtp.Focus();
            return;
        }

        myFilter = new Regex("[0-9]*");

        if (!myFilter.IsMatch(userOtp))
        {
            lblResult.Text = "The OTP you entered has an invalid character, so the request cannot be processed.";
            return;
        }


        if (pass == "")
        {
            lblResult.Text = "ERROR: Password is required.";
            txtPassword.Focus();
            return;
        }

        myFilter = new Regex("[0-9a-zA-Z'-_!]*");

        if (!myFilter.IsMatch(pass))
        {
            lblResult.Text = "The password you entered has an invalid character, so the request cannot be processed.";
            return;
        }

        if (passConfirm == "")
        {
            lblResult.Text = "ERROR: Confirm Password is required.";
            txtPasswordConfirm.Focus();
            return;
        }

        myFilter = new Regex("[0-9a-zA-Z'-_!]*");

        if (!myFilter.IsMatch(passConfirm))
        {
            lblResult.Text = "The confirm password you entered has an invalid character, so the request cannot be processed.";
            return;
        }

        if (passConfirm!=pass)
        {
            lblResult.Text = "The password and confirm password you entered do not match!";
            return;
        }
    

        // Look for user in DB
        OleDbConnection db = new OleDbConnection();
        db.ConnectionString = Configuration.ConnectionString;
// OTP
        try
        {  
            db.Open();
            String id=Request.QueryString["id"];
            sql = "SELECT * FROM ct_questions.CT_Contributors WHERE [ContributorID] = " + toSQL(id);

            OleDbCommand cmd = new OleDbCommand(sql, db);
            OleDbDataReader rdr = cmd.ExecuteReader();

            // If a match is found, assign the session variable to signify authorized.
            if (rdr.Read() == true)
            {
                String userId = rdr["ContributorID"].ToString();
				//Response.Redirect("RevLogin.aspx?msg=" + rdr["FirstName"].ToString());
                String name = rdr["FirstName"].ToString();
                String email = rdr["Email"].ToString();
                String otp = rdr["ForgotPasswordOTP"].ToString();
                //Verify OTP
                if(userOtp==otp){
                    sql = "UPDATE ct_questions.CT_Contributors SET Password = ? WHERE ContributorID = ?";
                    db = new OleDbConnection();
                    db.ConnectionString = Configuration.ConnectionString;
                    db.Open();
                    cmd = new OleDbCommand(sql, db);
                    cmd.Parameters.AddWithValue("Password", Crypto.HashPassword(pass));
                    cmd.Parameters.AddWithValue("ContributorID", userId);
                    cmd.ExecuteNonQuery();
                    SendMail(name, email, userId); 
                }
                else{
                    Response.Redirect("Default.aspx?msg=OTP is incorrect. Password not updated.");
                }
                
            }
            else
            {
                ClearAll();
                Response.Redirect("Default.aspx?msg=Your name is not recognized. Please contact the webmaster of this site.");
            }

            rdr.Close();
        }
        catch (Exception err)
        {
            lblResult.Text = "ERROR: There was a problem - " + err.Message + err.StackTrace;
        }
        finally
        {
            db.Close();
        }
    } 

    public void SendMail(String name, String email, String userId)
    {
        OleDbConnection db = new OleDbConnection();
        db.ConnectionString = Configuration.ConnectionString;

        try
        {
            // Email to person resetting password
            MailMessage requesterMail = new MailMessage();
            requesterMail.From = new MailAddress("techfit@purdue.edu");
            requesterMail.To.Add(email);
            requesterMail.Subject = "TECHFIT Password Reset Successful";
            requesterMail.Body = "Hi "+name
            +", you have successfully reset your password.";

            SmtpClient requesterClient = new SmtpClient();            
            requesterClient.Send(requesterMail);

            String sql = "UPDATE ct_questions.CT_Contributors SET ForgotPasswordOTP = ? WHERE ContributorID = ?";
                    db = new OleDbConnection();
                    db.ConnectionString = Configuration.ConnectionString;
                    db.Open();
                    OleDbCommand cmd = new OleDbCommand(sql, db);
                    cmd.Parameters.AddWithValue("ForgotPasswordOTP", null);
                    cmd.Parameters.AddWithValue("ContributorID", userId);
                    cmd.ExecuteNonQuery();
            
            db.Close();

            StringBuilder sb = new StringBuilder();
            String message="Password reset successfully! Please login with new credentials to continue!";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "');window.open('Default.aspx','_self');");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
        }
        catch (Exception ex)
        {
            lblErr.Text = ex.ToString();
        }

    }


   private void ClearAll()
        {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
        }

    // Helper method to filter the user's input
    private string toSQL(string stringValue)
    {
        string temp = stringValue.Replace("'", "''");
        temp = temp.Replace("<", "");
        temp = temp.Replace(">", "");
        temp = temp.Replace(";", " ");
        temp = temp.Replace(" OR ", " ");

        return "'" + temp + "'";
    }
}