﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Data.OleDb;
using System.Net.Mail;

using System.Collections.Generic;
using System.Linq;
using System.Collections;
using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;
using System.Net;
using System.Web.Script.Serialization;
using System.Web.UI.WebControls.WebParts;
using System.Drawing;

public partial class CTSignup : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        Page.MaintainScrollPositionOnPostBack = true;
        string msg = Request.QueryString["err"];
        lblErr.Text = msg;

        string msg2 = Request.QueryString["msg"];
        lblResult.Text = msg2;

        string msg3 = Request.QueryString["logout"];

        if (msg3 == "true")
        {
            ClearAll();
        }
    }
    
    protected void btnLogin_Click(object sender, EventArgs e)
    {

       
    }

    protected void Button1_Click(object sender, EventArgs e)
    {
       
    }

    protected void btnSignup_Click(object sender, EventArgs e)
    {
        String signupEmail = email.Text;
        String signupFirstName = txtFirstname.Text;
        String signupLastName = txtLastname.Text;
        String signupBio = bio.Text;
        String signupPhoneNumber = contact.Text;
        String signupExpertise = expertise.Text;
        String signupPosition = position.SelectedItem.Value;
        String signupOtherPosition = otherPosition.Text;
        String signupEmployer = employer.Text;
        String signupEmployerWebsite = employerWebsite.Text;
        String signupStudentGrade = grade.SelectedItem.Value;
        SendMail(signupEmail, signupFirstName, signupLastName, signupBio, signupPhoneNumber, signupExpertise, signupPosition, signupOtherPosition, signupEmployer, signupEmployerWebsite, signupStudentGrade); 
    }

    public void SendMail(String signupEmail, String signupFirstName, String signupLastName, String signupBio, String signupPhoneNumber, String signupExpertise, String signupPosition, String signupOtherPosition, String signupEmployer, String signupEmployerWebsite, String signupStudentGrade)
    {
        try
        {
            // Email to Admin for signup request
            MailMessage adminMail = new MailMessage();
            adminMail.From = new MailAddress(signupEmail);
            adminMail.To.Add("harrigea@purdue.edu");
            adminMail.Subject = "CT Tool Signup Request";
            adminMail.Body = "Hi Admin!"+"\n"
            +"You have received a signup request from "+signupFirstName+" "+signupLastName+"\n"
            +"Their Bio: "+signupBio+"\n"
            +"Subject Matter Expertise: "+signupExpertise+"\n"
            +"Position: "+signupPosition+"\n"
            +"Other Position (if any): "+signupOtherPosition+"\n"
            +"Employer: "+signupEmployer+"\n"+"\n"
            +"Employer Website: "+signupEmployerWebsite+"\n"+"\n"
            +"signupStudentGrade: "+signupStudentGrade+"\n"+"\n"
            +"Official Email: "+signupEmail+"\n"+"\n" 
            +"Contact Number: "+signupPhoneNumber;

            SmtpClient adminClient = new SmtpClient();            
            adminClient.Send(adminMail);

            // Email to person requesting signup
            MailMessage requesterMail = new MailMessage();
            requesterMail.From = new MailAddress("techfit@purdue.edu");
            requesterMail.To.Add(signupEmail);
            requesterMail.Subject = "CT Tool Signup Request Sent!";
            requesterMail.Body = "Hi "+signupFirstName
            +" "+signupLastName+", your signup request has been sent! You will receive an email from the admin with the login and password!";

            SmtpClient requesterClient = new SmtpClient();            
            requesterClient.Send(requesterMail);

            StringBuilder sb = new StringBuilder();
            String message="Signup request sent! You will receive an email from the admin with the login and password!";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "');window.open('Default.aspx','_self');");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
        }
        catch (Exception ex)
        {
            lblErr.Text = ex.ToString();
        }

    }

    protected void position_Change(object sender, EventArgs e)
        {
            if(position.SelectedIndex==3)
                otherPosition.Visible=true;
            else
            {
                otherPosition.Visible=false;
            }
            //stuff that never gets hit
        }

        protected void accessLevel_SelectedIndexChanged(object sender, EventArgs e)
    {
        String selVal = reqAccessLevel.SelectedValue;
        if(selVal=="Teacher"){
            positionDiv.Visible = true;
            gradeDiv.Visible = false;
        } else if(selVal=="Student"){
            gradeDiv.Visible = true;
            positionDiv.Visible = false;
            otherPosition.Visible = false;

        }  else {
            positionDiv.Visible = false;
            gradeDiv.Visible = false;
        }
    }

   private void ClearAll()
        {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
        }

    // Helper method to filter the user's input
    private string toSQL(string stringValue)
    {
        string temp = stringValue.Replace("'", "''");
        temp = temp.Replace("<", "");
        temp = temp.Replace(">", "");
        temp = temp.Replace(";", " ");
        temp = temp.Replace(" OR ", " ");

        return "'" + temp + "'";
    }
}