﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Data.OleDb;
using System.Web.Script.Serialization;
using System.Text;

public partial class CTStudentQuiz : System.Web.UI.Page
{
    String conStr = ConfigurationManager.ConnectionStrings["techfitConnectionStringNonODB"].ConnectionString.ToString();
    String conOLDBStr = ConfigurationManager.ConnectionStrings["techfitConnectionString"].ConnectionString.ToString();

    String quizDuration;
    int quizQuestions;
    String quizID;
    DataTable dt = new DataTable();
    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role!=3){
                Response.Redirect("Default.aspx");
            }
            if(Session["quizID"]!=null){
                quizID = Session["quizID"].ToString();
            }
            //Session["quizID"]=null;
            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
            if (!IsPostBack)
            {
                // Set number of questions and timer (in minutes) for a random quiz.
                quizDuration="25";
                quizQuestions=10;
                if(quizID!=null){
                    this.BindRepeaterViewAssignedMultipleChoiceQuestions(quizID);
                } else{
                    this.BindRepeaterViewAllMultipleChoiceQuestions();
                }
                Session["score"]=null;
                Session["incorrectAnswerListAsString"]=null;
                Session["correctAnswerListAsString"]=null;
            } else{
                spnthankyou.InnerHtml="Your quiz has been submitted!";
            }
            // Show hide elements on page load
            //SMFDiv.Visible=false;
        }
        catch (Exception exception)
        {
            lblErr.Text = exception.ToString();
            //Response.Redirect("Default.aspx");
        }
        
    }

public String GetTimer(){
    return quizDuration;
}

private void BindRepeaterViewAssignedMultipleChoiceQuestions(String quizID)
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    //cmd.CommandText = "select Q.ContributorID, QM.QuestionID, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10, QM.QFilename, QM.QAnswer, QM.Notes, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating FROM ct_questions.CT_Question_MC QM INNER JOIN ct_questions.CT_Questions Q ON QM.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON QM.QuestionID=QC.QuestionID  LEFT JOIN ct_questions.CT_QuestionPractice QP ON QM.QuestionID=QP.QuestionID WHERE Q.GradeLevel=@GradeLevel GROUP BY Q.ContributorID, QM.QuestionID, QM.QFilename, QM.QAnswer, QM.Notes, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10 ORDER BY AvgConceptAlignmentRating DESC";
                    cmd.CommandText = "select QuizTime, QuestionList from ct_questions.CT_Quiz where id=@quizID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "quizID";
                    param.Value = quizID;
                    cmd.Parameters.Add(param);
                    cmd.Connection = con;
                    con.Open();
                    SqlDataAdapter da = new SqlDataAdapter(cmd);
                    DataTable dt = new DataTable();
                    da.Fill(dt);
                    int quizTime = (from DataRow dr in dt.Rows
                                    select (int)dr["QuizTime"]).FirstOrDefault();
                    String questionListAsString = (from DataRow dr in dt.Rows
                                    select (String)dr["QuestionList"]).FirstOrDefault();
                    quizDuration=quizTime.ToString();
                    //String questionListAsString = (String) cmd.ExecuteScalar();
                    con.Close();
                    String strAppendQuestions = "";
                    String paramNameQuestions = "";
                    int index=1;
                    if(questionListAsString!=""){
                        String[] questionList = questionListAsString.Split(',');    
                        foreach(String item in questionList) {  
                            paramNameQuestions = "@idParam" + index;  
                            cmd.Parameters.AddWithValue(paramNameQuestions, Convert.ToInt32(item)); //Making individual parameters for every name  
                            strAppendQuestions += paramNameQuestions + ",";  
                            index += 1; 
                        } 
                        strAppendQuestions = strAppendQuestions.ToString().Remove(strAppendQuestions.LastIndexOf(","), 1); //Remove the last comma
                        //cmd.CommandText="Select TOP "+numQuestions.Text+" * from (select QuestionID from ct_questions.CT_QuestionConcept WHERE ConceptID IN (" + strAppendConcepts + ")) as cio ORDER BY NEWID()";
                        cmd.CommandText = "select Q.ContributorID, QM.QuestionID, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10, QM.QFilename, QM.QAnswer, QM.Notes, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating FROM ct_questions.CT_Question_MC QM INNER JOIN ct_questions.CT_Questions Q ON QM.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON QM.QuestionID=QC.QuestionID  LEFT JOIN ct_questions.CT_QuestionPractice QP ON QM.QuestionID=QP.QuestionID WHERE QM.QuestionID IN (" + strAppendQuestions + ") GROUP BY Q.ContributorID, QM.QuestionID, QM.QFilename, QM.QAnswer, QM.Notes, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10 ORDER BY AvgConceptAlignmentRating DESC";
                        //param.ParameterName = "GradeLevel";
                        //param.Value = Convert.ToInt32(Session["GradeLevel"]);
                        //cmd.Parameters.Add(param);
                        cmd.Connection = con;
                        con.Open();
                        rptAccordian.DataSource = cmd.ExecuteReader();
                        rptAccordian.DataBind();   
                        con.Close();
                        rowCountQuestions.Text = "# of Questions: "+rptAccordian.Items.Count;
                        if (rptAccordian.Items.Count < 1)
                        {
                            StringBuilder sb = new StringBuilder();
                            String message="No questions on this quiz! Please contact the administrator." + Session["GradeLevel"];
                            sb.Append("<script type='text/javascript'>");
                            sb.Append("alert('" + message + "'); window.open('CTStudentLanding.aspx','_self');");
                            sb.Append("</script>");
                            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
                        }
                    }

                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }

 private void BindRepeaterViewAllMultipleChoiceQuestions()
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    cmd.CommandText = "select top "+quizQuestions+" * from (select Q.ContributorID, QM.QuestionID, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10, QM.QFilename, QM.QAnswer, QM.Notes, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating FROM ct_questions.CT_Question_MC QM INNER JOIN ct_questions.CT_Questions Q ON QM.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON QM.QuestionID=QC.QuestionID  LEFT JOIN ct_questions.CT_QuestionPractice QP ON QM.QuestionID=QP.QuestionID WHERE Q.GradeLevel=@GradeLevel AND Q.QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC) GROUP BY Q.ContributorID, QM.QuestionID, QM.QFilename, QM.QAnswer, QM.Notes, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10) as cio ORDER BY NEWID()";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "GradeLevel";
                    param.Value = Convert.ToInt32(Session["GradeLevel"]);
                    cmd.Parameters.Add(param);
                    cmd.Connection = con;
                    con.Open();
                    rptAccordian.DataSource = cmd.ExecuteReader();
                    rptAccordian.DataBind();   
                    con.Close();
                    rowCountQuestions.Text = "# of Questions: "+rptAccordian.Items.Count;
                    if (rptAccordian.Items.Count < 1)
                    {
                        StringBuilder sb = new StringBuilder();
                        String message="No questions for the current grade level! Please contact the administrator." + Session["GradeLevel"];
                        sb.Append("<script type='text/javascript'>");
                        sb.Append("alert('" + message + "'); window.open('CTStudentLanding.aspx','_self');");
                        sb.Append("</script>");
                        ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
                    }
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.ToString();;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }


    protected void rptAccordian_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
       
    }



[System.Web.Services.WebMethod]
    public static string submitQuiz(string userID, string score, string correctAnswerListAsString, string incorrectAnswerListAsString){
        //showInsight(userID, correctAnswerListAsString);
        //lblInsight.Text="Insight: "+correctAnswerListAsString;
        HttpContext.Current.Session["score"]=score;
        HttpContext.Current.Session["studentID"]=userID;
        HttpContext.Current.Session["correctAnswerListAsString"]=correctAnswerListAsString;
        HttpContext.Current.Session["incorrectAnswerListAsString"]=incorrectAnswerListAsString;
        return "userID: " + userID+", score: "+score+", correctAnswerListAsString: "+correctAnswerListAsString;
    }

    protected void btnSubmitQuiz_Click(object sender, EventArgs e){
    //lblInsight.Text="Insight: "+Session["score"]+Session["studentID"]+Session["correctAnswerListAsString"]+Session["incorrectAnswerListAsString"];
    String correctAnswerListAsString = null;
    String[] correctAnswerList = null;
    String incorrectAnswerListAsString = null;
    String[] incorrectAnswerList = null;

    if(null!=Session["correctAnswerListAsString"]){
        correctAnswerListAsString = (String) Session["correctAnswerListAsString"];
        correctAnswerList = correctAnswerListAsString.Split(',');
    }
    if(null!=Session["incorrectAnswerListAsString"]){
        incorrectAnswerListAsString = (String) Session["incorrectAnswerListAsString"];
        incorrectAnswerList = incorrectAnswerListAsString.Split(',');
    }
    DateTime testDateTime = DateTime.Now;
    OleDbConnection db = null;
    db = new OleDbConnection();
            db.ConnectionString = conOLDBStr;
            db.Open();

            // For CT_Questions
            OleDbCommand cmdQuestions = db.CreateCommand();
            cmdQuestions.CommandText = "insert into ct_questions.CT_Student_Test_History (StudentID, TestScore, CorrectAnswerList, IncorrectAnswerList, TestDate, QuizID) values (?, ?, ?, ?, ?, ?)";
            cmdQuestions.Parameters.AddWithValue("@StudentID", Session["studentID"]);
            cmdQuestions.Parameters.AddWithValue("@TestScore", Session["score"]);
            cmdQuestions.Parameters.AddWithValue("@CorrectAnswerList", Session["correctAnswerListAsString"]);
            cmdQuestions.Parameters.AddWithValue("@IncorrectAnswerList", Session["incorrectAnswerListAsString"]);
            cmdQuestions.Parameters.AddWithValue("@TestDate", testDateTime);
            //lblInsight.Text = "quizID: "+quizID;
            if(Session["quizID"]!=null){
                cmdQuestions.Parameters.AddWithValue("@QuizID", Session["quizID"]);
            } else{
                cmdQuestions.Parameters.AddWithValue("@QuizID", 0);
            }
            
            cmdQuestions.ExecuteNonQuery();
            db.Close();
            
         Response.Redirect("CTStudentQuizReport.aspx");
    }


    
 protected void ItemBound(object sender, RepeaterItemEventArgs e)
    {
        String hfQuestionID = (e.Item.FindControl("hfQuestionID") as HiddenField).Value;

        RadioButtonList choicesRadioButtonList = (RadioButtonList)e.Item.FindControl("choicesRadioButtonList");

        try
        {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {
                using (SqlCommand cmdChildConcept = new SqlCommand())
                {
                    cmdChildConcept.CommandText = "select M.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10 from ct_questions.CT_Question_MC QM WHERE QuestionID = @QuesID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildConcept.Parameters.Add(param);

                    cmdChildConcept.Connection = conChild;
                    conChild.Open();
                    choicesRadioButtonList.DataSource = cmdChildConcept.ExecuteReader();
                    choicesRadioButtonList.DataTextField = "QM.Choice1";
                    choicesRadioButtonList.DataValueField = "QM.Choice1";
                    choicesRadioButtonList.DataBind();
                    conChild.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }

    }

    protected void grdquestions_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            RadioButtonList rdlstOptions = (RadioButtonList)e.Row.FindControl("rdlstOptions");
            HiddenField hdnquestionId = (HiddenField)e.Row.FindControl("hdnquestionId");
            if (rdlstOptions != null && hdnquestionId != null)
            {
                DataRow[] result = dt.Select("questionid=" + (Convert.ToInt32(hdnquestionId.Value)));
                DataView view = new DataView();
                view.Table = dt;
                view.RowFilter = "questionid=" + (Convert.ToInt32(hdnquestionId.Value));
                if (view.Table.Rows.Count > 0)
                {
                    DataTable dt1 = new DataTable();
                    dt1 = view.ToTable();
                }
            }
        }
    }  

    protected void goBack(object sender, EventArgs e)
    {
        Response.Redirect("CTStudentLanding.aspx");
    }
     protected void logout(object sender, EventArgs e)
    {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Session["quizID"] = null;
            Response.Redirect("Default.aspx");
    }
}

