﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;
using System.Net;
using System.Web.Script.Serialization;
using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;
using System.Web.UI.DataVisualization.Charting;

public partial class CTStudentQuizHistory : System.Web.UI.Page
{
    String conStr = ConfigurationManager.ConnectionStrings["techfitConnectionStringNonODB"].ConnectionString.ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role!=3){
                Response.Redirect("Default.aspx");
            }

            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
            if (!this.IsPostBack)
            {
                //string command = SqlDataSource1.SelectCommand; // added just for debug purpose
                SqlDataSource1.SelectCommand = "SELECT H.TestScore, H.TestDate, H.QuizID, Q.QuizName, H.StudentID FROM ct_questions.[CT_Student_Test_History] H LEFT JOIN ct_questions.[CT_Quiz] Q ON H.QuizID=Q.id WHERE H.StudentID="+Session["ContributorID"]+" ORDER BY TestDate DESC";
                SqlDataSource1.DataBind();
                GridView1.DataBind();

                SqlConnection con = new SqlConnection(System.Configuration.ConfigurationManager.ConnectionStrings["dev.techfitConnectionString1"].ConnectionString);
                    con.Open();
                    SqlCommand cmd = new SqlCommand("SELECT TestDate, TestScore FROM ct_questions.[CT_Student_Test_History] WHERE StudentID="+Session["ContributorID"]+" ORDER BY TestDate DESC");
                    cmd.Connection = con;
                    SqlDataAdapter da = new SqlDataAdapter(cmd);
                    DataTable dt = new DataTable();
                    da.Fill(dt);
                    Chart1.DataSource = dt;
                    
                    Chart1.Series["Series1"].XValueMember = "TestDate";
                    Chart1.Series["Series1"].YValueMembers = "TestScore";
                    Chart1.Series["Series1"].XValueType = ChartValueType.DateTime;
                    Chart1.Series["Series1"].BorderWidth = 3;  
                    Chart1.Series["Series1"].IsValueShownAsLabel=true;
                    Chart1.ChartAreas["ChartArea1"].AxisX.MajorGrid.Enabled = false;
                    Chart1.Series["Series1"].MarkerStyle = MarkerStyle.Circle;
                    Chart1.Series["Series1"].MarkerSize = 13;
                    Chart1.ChartAreas["ChartArea1"].AxisY.MajorGrid.Enabled = true;
                    Chart1.ChartAreas["ChartArea1"].AxisY.Title = "Score";
                    Chart1.ChartAreas["ChartArea1"].AxisY.Maximum = 100;
                    Chart1.ChartAreas["ChartArea1"].AxisY.Minimum = 0;
                    
                    Chart1.DataBind();
                    con.Close();
                BindRepeaterViewTestHistory();
            }
            // Show hide elements on page load
            //SMFDiv.Visible=false;
        }
        catch (Exception exception)
        {
            lblErr.Text = exception.ToString();
            //Response.Redirect("Default.aspx");
        }
    }

    protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {

        if (e.Row.RowType == DataControlRowType.DataRow)

        {

            if (e.Row.Cells[1].Text=="0")

            {

            e.Row.Cells[0].Text = "Random Quiz";

            }
        }

    }
    private void BindRepeaterViewTestHistory()
    {
        try
        {
            String contributorID = (String) Session["ContributorID"];
            
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand()){
                    cmd.CommandText = "SELECT TOP 1 * FROM ct_questions.[CT_Student_Test_History] WHERE StudentID="+Session["ContributorID"]+" ORDER BY TestDate DESC";
                    cmd.Connection = con;
                        //SqlParameter param = new SqlParameter();
                        //param.ParameterName = "@correctAnswerList";
                        //param.Value = Session["correctAnswerListAsString"];
                        //cmd.Parameters.Add(param);
                    con.Open();
                    //scoreRepeater.DataSource = cmd.ExecuteReader();
                    //DataTable dt = cmd.ExecuteReader();
                    SqlDataAdapter da = new SqlDataAdapter(cmd);
                    DataTable dt = new DataTable();
                    da.Fill(dt);
                    Decimal tScore = (from DataRow dr in dt.Rows
                                    select (Decimal)dr["TestScore"]).FirstOrDefault();
                    int tid = (from DataRow dr in dt.Rows
                                    select (int)dr["id"]).FirstOrDefault();
                    if(String.Equals(tid.ToString(), "0")){
                        StringBuilder sb = new StringBuilder();
                        String message="You have not taken a test yet! Please take a test to view performance.";
                        sb.Append("<script>");
                        sb.Append("confirm('" + message + "'); window.open('CTStudentLanding.aspx','_self');");
                        sb.Append("</script>");
                        ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
                        //ScriptManager.RegisterStartupScript(Page,GetType(),"disp_confirm",sb.ToString(),false);
                    }
                    lblScoreTest.Text = tScore.ToString();
                    String correctAnswerListAsString = (from DataRow dr in dt.Rows
                                    select (String)dr["CorrectAnswerList"]).FirstOrDefault();
                    String incorrectAnswerListAsString = (from DataRow dr in dt.Rows
                                    select (String)dr["IncorrectAnswerList"]).FirstOrDefault();                
                    con.Close();
                    if(tScore!=0){
                        giveInsightOnStrength(correctAnswerListAsString);
                    } else{
                        correctConcepts.Visible=false;
                    }
                    if(tScore!=100){
                        if(tScore!=0){
                            giveInsightOnWeakness(incorrectAnswerListAsString);
                        }
                    } else{
                        incorrectConcepts.Visible=false;
                    }
                }
            }
        } catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.Message;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error! Please try again!: " + exception.ToString();
        }
    }

    private void giveInsightOnStrength(String correctAnswerListAsString)
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    String[] correctAnswerList = correctAnswerListAsString.Split(',');
                    //int[] inValues = correctAnswerList.Split(',').Select(int.Parse).ToArray();
                    String strAppend = "";  
                    String strNames = "";  
                    int index = 1;  
                    String paramName = "";  
                    foreach(String item in correctAnswerList) {  
                        paramName = "@idParam" + index;  
                        cmd.Parameters.AddWithValue(paramName, Convert.ToInt32(item)); //Making individual parameters for every name  
                        strAppend += paramName + ",";  
                        index += 1; 
                    }  
                    strAppend = strAppend.ToString().Remove(strAppend.LastIndexOf(","), 1); //Remove the last comma
                    cmd.CommandText = "select ConceptName from ct_questions.CT_Concepts WHERE ConceptID IN (Select ConceptID FROM ct_questions.CT_QuestionConcept WHERE questionID IN (" + strAppend + "))";
                    cmd.Connection = con;
                    //SqlParameter param = new SqlParameter();
                    //param.ParameterName = "@correctAnswerList";
                    //param.Value = Session["correctAnswerListAsString"];
                    //cmd.Parameters.Add(param);
                    con.Open();
                    rptAccordianStrongConcepts.DataSource = cmd.ExecuteReader();
                    rptAccordianStrongConcepts.DataBind();   
                    con.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.Message;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error! Please try again!: " + exception.ToString();
        }
    }

    private void giveInsightOnWeakness(String incorrectAnswerListAsString)
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    String[] incorrectAnswerList = incorrectAnswerListAsString.Split(',');
                    //int[] inValues = correctAnswerList.Split(',').Select(int.Parse).ToArray();
                    String strAppend = "";  
                    String strNames = "";  
                    int index = 1;  
                    String paramName = "";  
                    foreach(String item in incorrectAnswerList) {  
                        paramName = "@idParam" + index;  
                        cmd.Parameters.AddWithValue(paramName, Convert.ToInt32(item)); //Making individual parameters for every name  
                        strAppend += paramName + ",";  
                        index += 1; 
                    }  
                    strAppend = strAppend.ToString().Remove(strAppend.LastIndexOf(","), 1); //Remove the last comma
                    cmd.CommandText = "select ConceptName from ct_questions.CT_Concepts WHERE ConceptID IN (Select ConceptID FROM ct_questions.CT_QuestionConcept WHERE questionID IN (" + strAppend + "))";
                    cmd.Connection = con;
                    //SqlParameter param = new SqlParameter();
                    //param.ParameterName = "@correctAnswerList";
                    //param.Value = Session["correctAnswerListAsString"];
                    //cmd.Parameters.Add(param);
                    con.Open();
                    rptAccordianWeakConcepts.DataSource = cmd.ExecuteReader();
                    rptAccordianWeakConcepts.DataBind();   
                    con.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.Message;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error! Please try again!: " + exception.ToString();
        }
    }
    protected void goBack(object sender, EventArgs e)
    {
        Response.Redirect("CTStudentLanding.aspx");
    }

    protected void logout(object sender, EventArgs e)
    {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Session["quizID"] = null;
            Response.Redirect("Default.aspx");
    }

    protected void goToTakeQuiz(object sender, EventArgs e)
    {
        Response.Redirect("CTStudentQuiz.aspx");
    }

}