﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Data.OleDb;

public partial class CTStudentQuizReport : System.Web.UI.Page
{
    String conStr = ConfigurationManager.ConnectionStrings["techfitConnectionStringNonODB"].ConnectionString.ToString();
    String conOLDBStr = ConfigurationManager.ConnectionStrings["techfitConnectionString"].ConnectionString.ToString();

    DataTable dt = new DataTable();
    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role!=3){
                Response.Redirect("Default.aspx");
            }
            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
            if (!IsPostBack)
            {
                this.BindRepeaterViewAllMultipleChoiceQuestions();

            } else{
            }
            // Show hide elements on page load
            //SMFDiv.Visible=false;
        }
        catch (Exception exception)
        {
            Response.Redirect("Default.aspx");
        }
        
    }

 private void BindRepeaterViewAllMultipleChoiceQuestions()
    {
        try
        {
            String testScoreAsString = (String) Session["score"];
            Decimal testScoreAsDecimal = Convert.ToDecimal(testScoreAsString);
            decimal dc = Math.Round(testScoreAsDecimal, 2);
            lblScoreTest.Text=dc.ToString();
            using (SqlConnection con = new SqlConnection(conStr))
            {
                if(Convert.ToInt32(Math.Floor(Convert.ToDouble(testScoreAsString)))!=0){
                    using (SqlCommand cmd = new SqlCommand())
                    {
                        giveInsightOnStrength();
                        String list = (String) Session["correctAnswerListAsString"];
                        String[] correctAnswerList = list.Split(',');
                        //int[] inValues = correctAnswerList.Split(',').Select(int.Parse).ToArray();
                        String strAppend = "";  
                        String strNames = "";  
                        int index = 1;  
                        String paramName = "";  
                        foreach(String item in correctAnswerList) {  
                            paramName = "@idParam" + index;  
                            cmd.Parameters.AddWithValue(paramName, Convert.ToInt32(item)); //Making individual parameters for every name  
                            strAppend += paramName + ",";  
                            index += 1; 
                        }  
                        strAppend = strAppend.ToString().Remove(strAppend.LastIndexOf(","), 1); //Remove the last comma
                        //cmd.CommandText = "select Q.ContributorID, QM.QuestionID, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10, QM.QFilename, QM.QAnswer, QM.Notes, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating FROM ct_questions.CT_Question_MC QM INNER JOIN ct_questions.CT_Questions Q ON QM.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON QM.QuestionID=QC.QuestionID  LEFT JOIN ct_questions.CT_QuestionPractice QP ON QM.QuestionID=QP.QuestionID WHERE Q.QuestionID IN ('@correctAnswerList') AND Q.GradeLevel=2 GROUP BY Q.ContributorID, QM.QuestionID, QM.QFilename, QM.QAnswer, QM.Notes, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10 ORDER BY AvgConceptAlignmentRating DESC";
                        cmd.CommandText = "select Q.ContributorID, QM.QuestionID, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10, QM.QFilename, QM.QAnswer, QM.Notes, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating FROM ct_questions.CT_Question_MC QM INNER JOIN ct_questions.CT_Questions Q ON QM.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON QM.QuestionID=QC.QuestionID  LEFT JOIN ct_questions.CT_QuestionPractice QP ON QM.QuestionID=QP.QuestionID"
                        +" WHERE Q.QuestionID IN (" + strAppend + ") GROUP BY Q.ContributorID, QM.QuestionID, QM.QFilename, QM.QAnswer, QM.Notes, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10 ORDER BY AvgConceptAlignmentRating DESC";
                        cmd.Connection = con;
                        SqlParameter param = new SqlParameter();
                        param.ParameterName = "@GradeLevel";
                        param.Value = Session["GradeLevel"];
                        cmd.Parameters.Add(param);
                        con.Open();
                        rptAccordianCorrectQuestions.DataSource = cmd.ExecuteReader();
                        rptAccordianCorrectQuestions.DataBind();   
                        con.Close();
                    }
                } else{
                    correctConcepts.Visible=false;
                    lblCorrect.Visible=false;
                    rptAccordianCorrectQuestions.Visible=false;
                }
                

                if(Convert.ToInt32(Math.Floor(Convert.ToDouble(testScoreAsString)))!=100){
                    using (SqlCommand cmd2 = new SqlCommand())
                    {
                        giveInsightOnWeakness();
                        String inList = (String) Session["incorrectAnswerListAsString"];
                        String[] incorrectAnswerList = inList.Split(',');
                        //int[] inValues = correctAnswerList.Split(',').Select(int.Parse).ToArray();
                        String strAppend = "";  
                        String strNames = "";  
                        int index = 1;  
                        String paramName = "";  
                        foreach(String item in incorrectAnswerList) {  
                            paramName = "@idParam" + index;  
                            cmd2.Parameters.AddWithValue(paramName, Convert.ToInt32(item)); //Making individual parameters for every name  
                            strAppend += paramName + ",";  
                            index += 1; 
                        }  
                        strAppend = strAppend.ToString().Remove(strAppend.LastIndexOf(","), 1); //Remove the last comma
                        //cmd2.CommandText = "select Q.ContributorID, QM.QuestionID, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10, QM.QFilename, QM.QAnswer, QM.Notes, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating FROM ct_questions.CT_Question_MC QM INNER JOIN ct_questions.CT_Questions Q ON QM.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON QM.QuestionID=QC.QuestionID  LEFT JOIN ct_questions.CT_QuestionPractice QP ON QM.QuestionID=QP.QuestionID WHERE Q.QuestionID IN ('@correctAnswerList') AND Q.GradeLevel=2 GROUP BY Q.ContributorID, QM.QuestionID, QM.QFilename, QM.QAnswer, QM.Notes, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10 ORDER BY AvgConceptAlignmentRating DESC";
                        cmd2.CommandText = "select Q.ContributorID, QM.QuestionID, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10, QM.QFilename, QM.QAnswer, QM.Notes, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating FROM ct_questions.CT_Question_MC QM INNER JOIN ct_questions.CT_Questions Q ON QM.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON QM.QuestionID=QC.QuestionID  LEFT JOIN ct_questions.CT_QuestionPractice QP ON QM.QuestionID=QP.QuestionID"
                        +" WHERE Q.QuestionID IN (" + strAppend + ") GROUP BY Q.ContributorID, QM.QuestionID, QM.QFilename, QM.QAnswer, QM.Notes, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10 ORDER BY AvgConceptAlignmentRating DESC";
                        cmd2.Connection = con;
                        SqlParameter param = new SqlParameter();
                        param.ParameterName = "@GradeLevel";
                        param.Value = (String) Session["GradeLevel"];
                        cmd2.Parameters.Add(param);
                        con.Open();
                        rptAccordianIncorrectQuestions.DataSource = cmd2.ExecuteReader();
                        rptAccordianIncorrectQuestions.DataBind();   
                        con.Close();
                    }
                } else{
                    incorrectConcepts.Visible=false;
                    lblIncorrect.Visible=false;
                    rptAccordianIncorrectQuestions.Visible=false;
                }

                
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.Message;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error! Please try again!: " + exception.ToString();
        }
    }

    private void giveInsightOnStrength()
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    String list = (String) Session["correctAnswerListAsString"];
                    String[] correctAnswerList = list.Split(',');
                    //int[] inValues = correctAnswerList.Split(',').Select(int.Parse).ToArray();
                    String strAppend = "";  
                    String strNames = "";  
                    int index = 1;  
                    String paramName = "";  
                    foreach(String item in correctAnswerList) {  
                        paramName = "@idParam" + index;  
                        cmd.Parameters.AddWithValue(paramName, Convert.ToInt32(item)); //Making individual parameters for every name  
                        strAppend += paramName + ",";  
                        index += 1; 
                    }  
                    strAppend = strAppend.ToString().Remove(strAppend.LastIndexOf(","), 1); //Remove the last comma
                    cmd.CommandText = "select ConceptName from ct_questions.CT_Concepts WHERE ConceptID IN (Select ConceptID FROM ct_questions.CT_QuestionConcept WHERE questionID IN (" + strAppend + "))";
                    cmd.Connection = con;
                    //SqlParameter param = new SqlParameter();
                    //param.ParameterName = "@correctAnswerList";
                    //param.Value = Session["correctAnswerListAsString"];
                    //cmd.Parameters.Add(param);
                    con.Open();
                    rptAccordianStrongConcepts.DataSource = cmd.ExecuteReader();
                    rptAccordianStrongConcepts.DataBind();   
                    con.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.Message;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error! Please try again!: " + exception.ToString();
        }
    }

    private void giveInsightOnWeakness()
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    String list = (String) Session["incorrectAnswerListAsString"];
                    String[] correctAnswerList = list.Split(',');
                    //int[] inValues = correctAnswerList.Split(',').Select(int.Parse).ToArray();
                    String strAppend = "";  
                    String strNames = "";  
                    int index = 1;  
                    String paramName = "";  
                    foreach(String item in correctAnswerList) {  
                        paramName = "@idParam" + index;  
                        cmd.Parameters.AddWithValue(paramName, Convert.ToInt32(item)); //Making individual parameters for every name  
                        strAppend += paramName + ",";  
                        index += 1; 
                    }  
                    strAppend = strAppend.ToString().Remove(strAppend.LastIndexOf(","), 1); //Remove the last comma
                    cmd.CommandText = "select ConceptName from ct_questions.CT_Concepts WHERE ConceptID IN (Select ConceptID FROM ct_questions.CT_QuestionConcept WHERE questionID IN (" + strAppend + "))";
                    cmd.Connection = con;
                    //SqlParameter param = new SqlParameter();
                    //param.ParameterName = "@correctAnswerList";
                    //param.Value = Session["correctAnswerListAsString"];
                    //cmd.Parameters.Add(param);
                    con.Open();
                    rptAccordianWeakConcepts.DataSource = cmd.ExecuteReader();
                    rptAccordianWeakConcepts.DataBind();   
                    con.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.Message;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error! Please try again!: " + exception.ToString();
        }
    }

    protected void grdquestions_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            RadioButtonList rdlstOptions = (RadioButtonList)e.Row.FindControl("rdlstOptions");
            HiddenField hdnquestionId = (HiddenField)e.Row.FindControl("hdnquestionId");
            if (rdlstOptions != null && hdnquestionId != null)
            {
                DataRow[] result = dt.Select("questionid=" + (Convert.ToInt32(hdnquestionId.Value)));
                DataView view = new DataView();
                view.Table = dt;
                view.RowFilter = "questionid=" + (Convert.ToInt32(hdnquestionId.Value));
                if (view.Table.Rows.Count > 0)
                {
                    DataTable dt1 = new DataTable();
                    dt1 = view.ToTable();
                }
            }
        }
    }  


    protected void goBack(object sender, EventArgs e)
    {
        Response.Redirect("CTStudentLanding.aspx");
    }
     protected void logout(object sender, EventArgs e)
    {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Session["quizID"] = null;
            Response.Redirect("Default.aspx");
    }
}

