﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;
using System.Net;
using System.Web.Script.Serialization;
using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;

public partial class CTTeacherBuildQuiz : System.Web.UI.Page
{
    String conStr = ConfigurationManager.ConnectionStrings["techfitConnectionStringNonODB"].ConnectionString.ToString();
    String conOLDBStr = ConfigurationManager.ConnectionStrings["techfitConnectionString"].ConnectionString.ToString();

    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role!=2){
                Response.Redirect("Default.aspx");
            }

            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
            if (!this.IsPostBack)
            {
                this.BindRepeaterConcepts();
                this.BindRepeaterHabits();
                this.BindRepeaterPractices();
                this.BindStudents();
            }
            // Show hide elements on page load
        }
        catch (Exception exception)
        {
            Response.Redirect("Default.aspx");
        }
    }


    private void BindRepeaterConcepts()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT ConceptID, ConceptName FROM ct_questions.CT_Concepts";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvConcepts.DataSource = dt;
                    lvConcepts.DataBind();
                }
            }
        }
    }

    private void BindRepeaterHabits()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT HabitId, HabitName FROM ct_questions.CT_Habits";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvHabits.DataSource = dt;
                    lvHabits.DataBind();
                }
            }
        }
    }

    private void BindRepeaterPractices()
    {
        using (SqlConnection con = new SqlConnection(conStr))
        {
            using (SqlCommand cmd = new SqlCommand())
            {
                cmd.CommandText = "SELECT PracticeId, PracticeName FROM ct_questions.CT_Practices";
                cmd.Connection = con;
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    lvPractices.DataSource = dt;
                    lvPractices.DataBind();
                }
            }
        }
    }

    private void BindStudents()
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    cmd.CommandText = "SELECT ContributorID, ContributorName FROM ct_questions.CT_Contributors WHERE Role=3 AND SchoolID=@SchoolID";
                    cmd.Parameters.AddWithValue("SchoolID", 10);
                    cmd.Connection = con;
                    using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                    {
                        DataTable dt = new DataTable();
                        sda.Fill(dt);
                        studentListBox.DataSource = dt;
                        studentListBox.DataValueField = "ContributorID";
                        studentListBox.DataTextField = "ContributorName";
                        studentListBox.DataBind();
                    }
                    con.Close();
                }
            }
        } catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! Message : " + exception.Message.ToString();
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }


    protected void ItemBoundConcept(object sender, RepeaterItemEventArgs e)
    {
        String lvConceptId = (e.Item.FindControl("lvConceptId") as HiddenField).Value;
        int conceptCount=0;
        Label conceptCounterLabel = (Label)e.Item.FindControl("conceptCounter");

        try
        {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {
                using (SqlCommand cmdChildConceptCount = new SqlCommand())
                {
                    cmdChildConceptCount.CommandText = "select COUNT(DISTINCT QuestionID) from ct_questions.CT_QuestionConcept WHERE ConceptID = @lvConceptId AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC)";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@lvConceptId";
                    param.Value = lvConceptId;
                    cmdChildConceptCount.Parameters.Add(param);

                    cmdChildConceptCount.Connection = conChild;
                    conChild.Open();
                    conceptCount = (int)cmdChildConceptCount.ExecuteScalar();
                    conceptCounterLabel.Text="[ "+conceptCount.ToString()+" ]";
                    conChild.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }

    }

    protected void ItemBoundHabit(object sender, RepeaterItemEventArgs e)
    {
        
    }

    protected void ItemBoundPractice(object sender, RepeaterItemEventArgs e)
    {
        String lvPracticeId = (e.Item.FindControl("lvPracticeId") as HiddenField).Value;
        int practiceCount=0;
        Label practiceCounterLabel = (Label)e.Item.FindControl("practiceCounter");

        try
        {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {
                using (SqlCommand cmdChildPracticeCount = new SqlCommand())
                {
                    cmdChildPracticeCount.CommandText = "select COUNT(DISTINCT QuestionID) from ct_questions.CT_QuestionPractice WHERE PracticeID = @lvPracticeId AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC)";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@lvPracticeId";
                    param.Value = lvPracticeId;
                    cmdChildPracticeCount.Parameters.Add(param);

                    cmdChildPracticeCount.Connection = conChild;
                    conChild.Open();
                    practiceCount = (int)cmdChildPracticeCount.ExecuteScalar();
                    practiceCounterLabel.Text="[ "+practiceCount.ToString()+" ]";
                    conChild.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }

    }


    protected void selectConceptIntoLabel_Click(object sender, CommandEventArgs e)
    {       
        int questionCount = 0;
        String selectedValue = e.CommandArgument.ToString();
        String[] selectedValueArr = selectedValue.Split(',');
        selectedConcepts.Value+=selectedValueArr[1]+",";
        if(selectedConceptVals.Text==""){
            selectedConceptVals.Text+=selectedValueArr[0];
        } else{
            selectedConceptVals.Text+="\n"+selectedValueArr[0];
        }
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                    {
                        //int[] inValues = correctAnswerList.Split(',').Select(int.Parse).ToArray();
                        String strAppendConcepts = "";  
                        String strAppendPractices = ""; 
                        String strNames = "";  
                        int index = 1;  
                        String paramNameConcepts = "";  
                        String paramNamePractices = "";  
                        String conceptListAsString = selectedConcepts.Value;
    
                        conceptListAsString = conceptListAsString.ToString().Remove(conceptListAsString.LastIndexOf(","), 1); //Remove the last comma  
                        String[] conceptList = conceptListAsString.Split(',');    
                            foreach(String item in conceptList) {  
                                paramNameConcepts = "@idParam" + index;  
                                cmd.Parameters.AddWithValue(paramNameConcepts, Convert.ToInt32(item)); //Making individual parameters for every name  
                                strAppendConcepts += paramNameConcepts + ",";  
                                index += 1; 
                            } 
                        strAppendConcepts = strAppendConcepts.ToString().Remove(strAppendConcepts.LastIndexOf(","), 1); //Remove the last comma
                        
                        
                        String practiceListAsString = selectedPractices.Value;
                        if(practiceListAsString!=""){
                            practiceListAsString = practiceListAsString.ToString().Remove(practiceListAsString.LastIndexOf(","), 1); //Remove the last comma  
                            String[] practiceList = practiceListAsString.Split(',');
                            foreach(String item in practiceList) {  
                                paramNamePractices = "@idParam" + index;  
                                cmd.Parameters.AddWithValue(paramNamePractices, Convert.ToInt32(item)); //Making individual parameters for every name  
                                strAppendPractices += paramNamePractices + ",";  
                                index += 1; 
                            }
                            strAppendPractices = strAppendPractices.ToString().Remove(strAppendPractices.LastIndexOf(","), 1); //Remove the last comma  
                            cmd.CommandText = "Select COUNT(*) from (select QuestionID from ct_questions.CT_QuestionConcept"
                        +" WHERE ConceptID IN (" + strAppendConcepts + ") AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC) UNION Select QuestionID from ct_questions.CT_QuestionPractice where PracticeID IN (" + strAppendPractices + ") AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC)) as counter";
                        
                        }else{
                            cmd.CommandText = "Select COUNT(QuestionID) from ct_questions.CT_QuestionConcept"
                        +" WHERE ConceptID IN (" + strAppendConcepts + ") AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC)";
                        
                        }
                        //cmd.CommandText = "select Q.ContributorID, QM.QuestionID, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10, QM.QFilename, QM.QAnswer, QM.Notes, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating FROM ct_questions.CT_Question_MC QM INNER JOIN ct_questions.CT_Questions Q ON QM.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON QM.QuestionID=QC.QuestionID  LEFT JOIN ct_questions.CT_QuestionPractice QP ON QM.QuestionID=QP.QuestionID WHERE Q.QuestionID IN ('@correctAnswerList') AND Q.GradeLevel=2 GROUP BY Q.ContributorID, QM.QuestionID, QM.QFilename, QM.QAnswer, QM.Notes, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10 ORDER BY AvgConceptAlignmentRating DESC";
                        cmd.Connection = con;
                        con.Open();
                        questionCount = (int)cmd.ExecuteScalar();
                        totalNumberQuestions.Text=questionCount.ToString();  
                        con.Close();
                    }
            }
        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.Message;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception;
        }
        
    }

    protected void selectHabitIntoLabel_Click(object sender, CommandEventArgs e)
    {       


    }
    
    protected void selectPracticeIntoLabel_Click(object sender, CommandEventArgs e)
    {       
        int questionCount = 0;
        String selectedValue = e.CommandArgument.ToString();
        String[] selectedValueArr = selectedValue.Split(',');
        selectedPractices.Value+=selectedValueArr[1]+",";
        if(selectedPracticeVals.Text==""){
            selectedPracticeVals.Text=selectedValueArr[0];
        } else{
            selectedPracticeVals.Text+="\n"+selectedValueArr[0];
        }
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                    {
                        //int[] inValues = correctAnswerList.Split(',').Select(int.Parse).ToArray();
                        String strAppendConcepts = "";  
                        String strAppendPractices = ""; 
                        String strNames = "";  
                        int index = 1;  
                        String paramNameConcepts = "";  
                        String paramNamePractices = "";  
                        
                        String practiceListAsString = selectedPractices.Value;

                        practiceListAsString = practiceListAsString.ToString().Remove(practiceListAsString.LastIndexOf(","), 1); //Remove the last comma  
                        String[] practiceList = practiceListAsString.Split(',');
                            foreach(String item in practiceList) {  
                                paramNamePractices = "@idParam" + index;  
                                cmd.Parameters.AddWithValue(paramNamePractices, Convert.ToInt32(item)); //Making individual parameters for every name  
                                strAppendPractices += paramNamePractices + ",";  
                                index += 1; 
                            }
                        strAppendPractices = strAppendPractices.ToString().Remove(strAppendPractices.LastIndexOf(","), 1); //Remove the last comma  
                            
                        String conceptListAsString = selectedConcepts.Value;
                        
    
                        if(conceptListAsString!=""){
                            conceptListAsString = conceptListAsString.ToString().Remove(conceptListAsString.LastIndexOf(","), 1); //Remove the last comma  
                            String[] conceptList = conceptListAsString.Split(',');
                            foreach(String item in conceptList) {  
                                paramNameConcepts = "@idParam" + index;  
                                cmd.Parameters.AddWithValue(paramNameConcepts, Convert.ToInt32(item)); //Making individual parameters for every name  
                                strAppendConcepts += paramNameConcepts + ",";  
                                index += 1; 
                            } 
                            strAppendConcepts = strAppendConcepts.ToString().Remove(strAppendConcepts.LastIndexOf(","), 1); //Remove the last comma
                            cmd.CommandText = "Select COUNT(*) from (select QuestionID from ct_questions.CT_QuestionConcept"
                            +" WHERE ConceptID IN (" + strAppendConcepts + ") AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC) UNION Select QuestionID from ct_questions.CT_QuestionPractice where PracticeID IN (" + strAppendPractices + ") AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC)) as counter";
                            
                        }else{
                            cmd.CommandText = "Select COUNT(QuestionID) from ct_questions.CT_QuestionPractice"
                        +" WHERE PracticeID IN (" + strAppendPractices + ") AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC)";
                        
                        }
                        //lblResult.Text="conceptListAsString: "+conceptListAsString+", practiceListAsString: "+practiceListAsString;
                        //cmd.CommandText = "select Q.ContributorID, QM.QuestionID, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10, QM.QFilename, QM.QAnswer, QM.Notes, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating FROM ct_questions.CT_Question_MC QM INNER JOIN ct_questions.CT_Questions Q ON QM.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON QM.QuestionID=QC.QuestionID  LEFT JOIN ct_questions.CT_QuestionPractice QP ON QM.QuestionID=QP.QuestionID WHERE Q.QuestionID IN ('@correctAnswerList') AND Q.GradeLevel=2 GROUP BY Q.ContributorID, QM.QuestionID, QM.QFilename, QM.QAnswer, QM.Notes, QM.QText, QM.QNbrChoices, QM.Choice1, QM.Choice2, QM.Choice3, QM.Choice4, QM.Choice5, QM.Choice6, QM.Choice7, QM.Choice8, QM.Choice9, QM.Choice10 ORDER BY AvgConceptAlignmentRating DESC";
                        cmd.Connection = con;
                        con.Open();
                        questionCount = (int)cmd.ExecuteScalar();
                        totalNumberQuestions.Text=questionCount.ToString();  
                        con.Close();
                    }
            }
        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.Message;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception;
        }
        
    }

    protected void buildQuizButton_Click(object sender, EventArgs e)
    {
        OleDbConnection db = null;
        int qID = 0, rated=0;
        String strAppendConcepts = "";  
        String strAppendPractices = ""; 
        String strNames = "";  
        int index = 1;
        String paramNameConcepts = "";  
        String paramNamePractices = ""; 
        StringBuilder studentList = new StringBuilder();
        String studentListAsString = null;
        StringBuilder questionList = new StringBuilder();
        String questionListAsString = null;
        
        String numQuestionsStr = numQuestions.Text;
        String durationStr = duration.Text;
        String quizNameStr = quizName.Text;


        // Validation
        Regex myFilter = new Regex("[0-9a-zA-Z-_,@;]");


        try
        {
            //Validation
            if (numQuestionsStr == "")
            {
                lblErrValidation.Text = "Number of questions is required!";
                numQuestions.Focus();
                return;
            }

            if (Convert.ToInt32(numQuestionsStr) > Convert.ToInt32(totalNumberQuestions.Text))
            {
                lblErrValidation.Text = "Number of questions selected should be less than the total quetions possible!";
                numQuestions.Focus();
                return;
            }

            if (durationStr == "")
            {
                lblErrValidation.Text = "Duration is required!";
                duration.Focus();
                return;
            }

            if (Convert.ToInt32(durationStr) <= 0)
            {
                lblErrValidation.Text = "Enter a value greater than 0!";
                duration.Focus();
                return;
            }

            if (quizNameStr == "")
            {
                lblErrValidation.Text = "Quiz name is required!";
                quizName.Focus();
                return;
            }

            if (!myFilter.IsMatch(quizNameStr))
            {
                lblErrValidation.Text = "The quiz name you entered is invalid!";
                return;
            }

            String contributorID = Session["ContributorID"].ToString();
            ListItemCollection listBoxData = new ListItemCollection();
            listBoxData = studentListBox.Items;
            if (studentListBox.SelectedIndex == -1)
            {
                lblErrValidation.Text = "Select at least one student!";
                studentListBox.Focus();
                return;
            }
            String sitem = "";
            foreach (ListItem item in studentListBox.Items)
                {
                    if (item.Selected)
                    {
                        studentList.Append(item.Value.ToString());
                        studentList.Append(",");
                    }
                }
            studentListAsString = studentList.ToString();
            studentListAsString = studentListAsString.Remove(studentListAsString.LastIndexOf(","), 1); //Remove the last comma  
            
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                    {
                        if(selectedConcepts.Value!=""){
                            String conceptListAsString = selectedConcepts.Value;
                            conceptListAsString = conceptListAsString.ToString().Remove(conceptListAsString.LastIndexOf(","), 1); //Remove the last comma  
                            String[] conceptList = conceptListAsString.Split(',');    
                                foreach(String item in conceptList) {  
                                    paramNameConcepts = "@idParam" + index;  
                                    cmd.Parameters.AddWithValue(paramNameConcepts, Convert.ToInt32(item)); //Making individual parameters for every name  
                                    strAppendConcepts += paramNameConcepts + ",";  
                                    index += 1; 
                                } 
                            strAppendConcepts = strAppendConcepts.ToString().Remove(strAppendConcepts.LastIndexOf(","), 1); //Remove the last comma
                            
                        }
                        if(selectedPractices.Value!=""){
                            String practiceListAsString = selectedPractices.Value;
                            practiceListAsString = practiceListAsString.ToString().Remove(practiceListAsString.LastIndexOf(","), 1); //Remove the last comma  
                            String[] practiceList = practiceListAsString.Split(',');
                                foreach(String item in practiceList) {  
                                    paramNamePractices = "@idParam" + index;  
                                    cmd.Parameters.AddWithValue(paramNamePractices, Convert.ToInt32(item)); //Making individual parameters for every name  
                                    strAppendPractices += paramNamePractices + ",";  
                                    index += 1; 
                                }
                            strAppendPractices = strAppendPractices.ToString().Remove(strAppendPractices.LastIndexOf(","), 1); //Remove the last comma  
                                
                        }

                        if(selectedPractices.Value==""){
                            cmd.CommandText="Select TOP "+numQuestions.Text+" * from (select QuestionID from ct_questions.CT_QuestionConcept WHERE ConceptID IN (" + strAppendConcepts + ") AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC)) as cio ORDER BY NEWID()";
                        }
                        else if(selectedConcepts.Value==""){
                            cmd.CommandText="Select TOP "+numQuestions.Text+" * from (Select QuestionID from ct_questions.CT_QuestionPractice where PracticeID IN (" + strAppendPractices + ") AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC)) as cio ORDER BY NEWID()";
                        }
                        else{
                        cmd.CommandText="Select TOP "+numQuestions.Text+" * from (select QuestionID from ct_questions.CT_QuestionConcept WHERE ConceptID IN (" + strAppendConcepts + ") AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC) UNION Select QuestionID from ct_questions.CT_QuestionPractice where PracticeID IN (" + strAppendPractices + ") AND QuestionID IN (Select QuestionID from ct_questions.CT_Question_MC)) as cio ORDER BY NEWID()";
                        }
                        
                       cmd.Connection = con;
                        using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                        {
                            DataTable dt = new DataTable();
                            sda.Fill(dt);
                            foreach(DataRow row in dt.Rows)
                            {
                                questionList.Append(row["QuestionID"].ToString());
                                questionList.Append(",");
                            }
                            questionListAsString = questionList.ToString();
                            questionListAsString = questionListAsString.Remove(questionListAsString.LastIndexOf(","), 1); //Remove the last comma  
                            
                        }
                        con.Close();
                    }
            }

            db = new OleDbConnection();
            db.ConnectionString = conOLDBStr;
            db.Open();

            // For CT_Quiz
            OleDbCommand cmdQuestions = db.CreateCommand();
            cmdQuestions.CommandText = "insert into ct_questions.CT_Quiz (TeacherID, QuestionList, StudentsList, QuizTime, QuizName) values (?, ?, ?, ?, ?)";
            cmdQuestions.Parameters.AddWithValue("@TeacherID", Session["ContributorID"]);
            cmdQuestions.Parameters.AddWithValue("@QuestionList", questionListAsString);
            cmdQuestions.Parameters.AddWithValue("@StudentsList", studentListAsString);
            cmdQuestions.Parameters.AddWithValue("@QuizTime", duration.Text);
            cmdQuestions.Parameters.AddWithValue("@QuizName", quizNameStr);
            
            cmdQuestions.ExecuteNonQuery();
            db.Close();

            StringBuilder sb = new StringBuilder();
            String message="Quiz Added! It will now be available to the students you have assigned it to.";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "'); window.open('CTTeacherLanding.aspx','_self');");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again!";
            StringBuilder sb = new StringBuilder();
            String message="Quiz not added. Please contact the administrator.";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "');");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception;
            StringBuilder sb = new StringBuilder();
            String message="Quiz not added. Please contact the administrator.";
            sb.Append("<script type='text/javascript'>");
            sb.Append("alert('" + message + "');");
            sb.Append("</script>");
            ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
        }

    }

    protected void reloadSelectorConcepts_Click(object sender, EventArgs e)
    {
        selectedConcepts.Value=null;
        selectedConceptVals.Text=null;
        totalNumberQuestions.Text="0";

    }

    protected void reloadSelectorPractices_Click(object sender, EventArgs e)
    {
        selectedPractices.Value=null;
        selectedPracticeVals.Text=null;
        totalNumberQuestions.Text="0";

    }

    protected void reloadSelectorStudents_Click(object sender, EventArgs e)
    {
        foreach (ListItem item in studentListBox.Items){
            item.Selected = false;                                       
        }
        ClientScript.RegisterStartupScript(this.GetType(), "hash", "location.hash = '#scrollPosStudents';", true);
    }

    protected void selectAllSelectorStudents_Click(object sender, EventArgs e)
    {
        foreach (ListItem item in studentListBox.Items){
            item.Selected = true;                                       
        }
        ClientScript.RegisterStartupScript(this.GetType(), "hash", "location.hash = '#scrollPosStudents';", true);
    }

    protected void goBack(object sender, EventArgs e)
    {
        Response.Redirect("CTTeacherLanding.aspx");
    }
    protected void logout(object sender, EventArgs e)
    {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Response.Redirect("Default.aspx");
    }

    protected void goToAddNewQuestion(object sender, EventArgs e)
    {
        Response.Redirect("CTAddNewQuestion.aspx");
    }

    protected void goToViewAllQuestions(object sender, EventArgs e)
    {
        Response.Redirect("CTViewAllQuestions.aspx");
    }

    protected void goToViewOpenEQuestions(object sender, EventArgs e)
    {
        Response.Redirect("CTViewOpenEQuestions.aspx");
    }

    protected void goToViewCloseEQuestions(object sender, EventArgs e)
    {
        Response.Redirect("CTViewCloseEQuestions.aspx");
    }

    protected void addNewUser(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminAddNewUser.aspx");
    }

    protected void modifyHabit(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminModifyHabit.aspx");
    }

    protected void modifyConcept(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminModifyConcept.aspx");
    }

    protected void modifyPractice(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminModifyPractices.aspx");
    }

    protected void deleteUser(object sender, EventArgs e)
    {
        Response.Redirect("CTAdminDeleteUser.aspx");
    }

    protected void categorySA(object sender, EventArgs e)
    {
        Response.Redirect("CTSingleAnswer.aspx");
    }

    protected void reloadSelection(object sender, EventArgs e)
    {
        Response.Redirect("CTTeacherLanding.aspx");
    }

    protected void goToViewClassPerformance(object sender, EventArgs e)
    {
        Response.Redirect("CTTeacherViewClassPerformance.aspx");
    }
    

    
    
    


}