﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using System.Data.OleDb;
using System.Data;

using System.Text;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.IO;

using System.Net;
using System.Web.Script.Serialization;


using System.Web.UI.WebControls.WebParts;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;

public partial class CTViewOpenEQuestions : System.Web.UI.Page
{
    String conStr = ConfigurationManager.ConnectionStrings["techfitConnectionStringNonODB"].ConnectionString.ToString();
    
    protected void Page_Load(object sender, EventArgs e)
    {

        try
        {
            // Verify authorized user
            int role = Convert.ToInt32(Session["Role"].ToString());
            if(role==3){
                Response.Redirect("Default.aspx");
            }
            welcomeBox.InnerHtml = Session["ContributorWelcomeMsg"].ToString();
 
            if (!this.IsPostBack)
            {
                this.BindRepeaterViewAllTextualQuestions();
                //this.BindRepeaterViewAllFileTypeQuestions();
            }

            // Adapt page depending on role
            //Admin
            if (role == 1)
            {
                for (int i = 0; i <= rptAccordianSA.Items.Count - 1; i++)
                {
                    Button deleteBtnSA = (Button)rptAccordianSA.Items[i].FindControl("deleteQuestion");
                    deleteBtnSA.Visible = true;
                }
                for (int k = 0; k <= rptAccordianFT.Items.Count - 1; k++)
                {
                    Button deleteBtnFT = (Button)rptAccordianFT.Items[k].FindControl("deleteQuestion");
                    deleteBtnFT.Visible = true;
                }
                addQuestionPanel.Visible=true;
            }
            //Teacher
            else if (role == 2)
            {
                addQuestionPanel.Visible=true;
                for (int i = 0; i <= rptAccordianSA.Items.Count - 1; i++)
                {
                    Button deleteBtnSA = (Button)rptAccordianSA.Items[i].FindControl("markDeleteQuestion");
                    deleteBtnSA.Visible = true;
                }
                for (int k = 0; k <= rptAccordianFT.Items.Count - 1; k++)
                {
                    Button deleteBtnFT = (Button)rptAccordianFT.Items[k].FindControl("markDeleteQuestion");
                    deleteBtnFT.Visible = true;
                }

            }
            //Expert
            else if (role == 4)
            {
                for (int i = 0; i <= rptAccordianSA.Items.Count - 1; i++)
                {
                    Button deleteBtn = (Button)rptAccordianSA.Items[i].FindControl("deleteQuestion");
                    deleteBtn.Visible = false;
                }
                for (int k = 0; k <= rptAccordianFT.Items.Count - 1; k++)
                {
                    Button deleteBtnFT = (Button)rptAccordianFT.Items[k].FindControl("deleteQuestion");
                    deleteBtnFT.Visible = false;
                }
                addQuestionPanel.Visible=false;
            }
            //Contributor
            else if (role == 5)
            {
                for (int i = 0; i <= rptAccordianSA.Items.Count - 1; i++)
                {
                    Button rateBtnSA = (Button)rptAccordianSA.Items[i].FindControl("rateQuestion");
                    Button deleteBtnSA = (Button)rptAccordianSA.Items[i].FindControl("deleteQuestion");
                    rateBtnSA.Visible = false;
                    deleteBtnSA.Visible = false;
                }
                for (int k = 0; k <= rptAccordianFT.Items.Count - 1; k++)
                {
                    Button rateBtnFT = (Button)rptAccordianFT.Items[k].FindControl("rateQuestion");
                    Button deleteBtnFT = (Button)rptAccordianFT.Items[k].FindControl("deleteQuestion");
                    rateBtnFT.Visible = false;
                    deleteBtnFT.Visible = false;
                }
                addQuestionPanel.Visible=true;
            }
            //Viewer
            else if (role == 6)
            {
                for (int i = 0; i <= rptAccordianSA.Items.Count - 1; i++)
                {
                    Button rateBtnSA = (Button)rptAccordianSA.Items[i].FindControl("rateQuestion");
                    Button deleteBtnSA = (Button)rptAccordianSA.Items[i].FindControl("deleteQuestion");
                    rateBtnSA.Visible = false;
                    deleteBtnSA.Visible = false;
                }
                for (int k = 0; k <= rptAccordianFT.Items.Count - 1; k++)
                {
                    Button rateBtnFT = (Button)rptAccordianFT.Items[k].FindControl("rateQuestion");
                    Button deleteBtnFT = (Button)rptAccordianFT.Items[k].FindControl("deleteQuestion");
                    rateBtnFT.Visible = false;
                    deleteBtnFT.Visible = false;
                }
                addQuestionPanel.Visible=false;
            }

        }
        catch (Exception exception)
        {
            lblErr.Text = "An error occured. Please try again later!"+ exception.Message;
            //lblErr.Text = exception.Message;
           Response.Redirect("Default.aspx");

        }
        
    }   

    protected void goToAddNewQuestion(object sender, EventArgs e)
    {
        Response.Redirect("CTAddNewQuestion.aspx");
    }

    protected void rateQuesSA_Click(object sender, CommandEventArgs e)
    {
        Session["questionID"] = e.CommandArgument.ToString();
        Session["questionType"] = "1";

        Response.Redirect("CTRateQuestion.aspx");
    }
    protected void rateQuesFT_Click(object sender, CommandEventArgs e)
    {
        Session["questionID"] = e.CommandArgument.ToString();
        Session["questionType"] = "3";

        Response.Redirect("CTRateQuestion.aspx");
    }

    protected void deleteQuesSA_Click(object sender, CommandEventArgs e)
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    cmd.CommandText = "delete from ct_questions.CT_Questions WHERE QuestionID = @QuesID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = e.CommandArgument.ToString();
                    cmd.Parameters.Add(param);
                    cmd.Connection = con;
                    con.Open();
                    rptAccordianSA.DataSource = cmd.ExecuteReader();
                    rptAccordianSA.DataBind();
                    con.Close();
                    StringBuilder sb = new StringBuilder();
                    String message="Question deleted!";
                    sb.Append("<script type='text/javascript'>");
                    sb.Append("alert('" + message + "'); window.open('CTViewOpenEQuestions.aspx','_self');");
                    sb.Append("</script>");
                    ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "ajax", sb.ToString(), false);
                }
            }
            Response.Redirect(Page.Request.RawUrl,false);

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }

    protected void markDeleteQuesSA_Click(object sender, CommandEventArgs e)
    {
        try
        {
            Session["questionID"] = e.CommandArgument.ToString();
            Session["questionType"] = "1";
            Response.Redirect("CTMarkQuestionForDeletion.aspx");

        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }

    protected void markDeleteQuesMC_Click(object sender, CommandEventArgs e)
    {
        try
        {
            Session["questionID"] = e.CommandArgument.ToString();
            Session["questionType"] = "2";
            Response.Redirect("CTMarkQuestionForDeletion.aspx");

        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }

    protected void deleteQuesFT_Click(object sender, CommandEventArgs e)
    {
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    cmd.CommandText = "delete from ct_questions.CT_Questions WHERE QuestionID = @QuesID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = e.CommandArgument.ToString();
                    cmd.Parameters.Add(param);
                    cmd.Connection = con;
                    con.Open();
                    rptAccordianFT.DataSource = cmd.ExecuteReader();
                    rptAccordianFT.DataBind();
                    con.Close();
                }
            }
            Response.Redirect(Page.Request.RawUrl,false);

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }


    private void BindRepeaterViewAllTextualQuestions()
    {
        String lvConceptId = null;
        String lvHabitId = null;
        String lvPracticeId = null;
        try
        {
            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    cmd.CommandText = "select S.QText, S.QFilename, S.QAnswer, S.Notes, Q.GradeLevel, Q.Source, Q.ContributorID, S.QuestionID, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_Question_SA S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID GROUP BY S.QText, S.QAnswer, S.Notes, Q.GradeLevel, S.QuestionID, Q.ContributorID, Q.Source, S.QFilename";
                    cmd.Connection = con;
                    con.Open();
                    rptAccordianSA.DataSource = cmd.ExecuteReader();
                    rptAccordianSA.DataBind();
                    con.Close();
                    rowCountQuestionsSA.Text = "# of Questions: "+rptAccordianSA.Items.Count;
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }
    }
    
    private void BindRepeaterViewAllFileTypeQuestions()
    {
        String lvConceptId = null;
        String lvHabitId = null;
        String lvPracticeId = null;
        try
        {
            lvConceptId = Request.QueryString["lvConceptId"];
            lvHabitId = Request.QueryString["lvHabitId"];
            lvPracticeId = Request.QueryString["lvPracticeId"];

            using (SqlConnection con = new SqlConnection(conStr))
            {
                using (SqlCommand cmd = new SqlCommand())
                {
                    cmd.CommandText = "select S.QFilename, S.QAnswer, Q.Source, Q.ContributorID, S.Notes, Q.GradeLevel, S.QuestionID, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_Question_File S INNER JOIN ct_questions.CT_Questions Q ON S.QuestionID=Q.QuestionID LEFT JOIN ct_questions.CT_QuestionConcept QC ON S.QuestionID=QC.QuestionID LEFT JOIN ct_questions.CT_QuestionHabit QH ON S.QuestionID=QH.QuestionID LEFT JOIN ct_questions.CT_QuestionPractice QP ON S.QuestionID=QP.QuestionID WHERE S.OpenEnded=1 GROUP BY S.QFilename, S.QAnswer, S.Notes, Q.GradeLevel, S.QuestionID, Q.ContributorID, Q.Source";
                    cmd.Connection = con;
                    con.Open();
                    rptAccordianFT.DataSource = cmd.ExecuteReader();
                    rptAccordianFT.DataBind();
                    con.Close();
                    rowCountQuestionsFT.Text = "# of Questions: "+rptAccordianFT.Items.Count;
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.Message;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.StackTrace;
        }
    }

    protected void ItemBound(object sender, RepeaterItemEventArgs e)
    {
        String hfQuestionID = (e.Item.FindControl("hfQuestionID") as HiddenField).Value;
        String hfContributorID = (e.Item.FindControl("hfContributorID") as HiddenField).Value;
        Button deleteQuestion = (Button)e.Item.FindControl("deleteQuestion");
        Label contNameLabel = (Label)e.Item.FindControl("contrName");
        String contName = null;

        if (hfContributorID.Equals(Session["ContributorID"].ToString()))
        {
            deleteQuestion.Visible = true;
        }
        Repeater childRepeaterForConcept = (Repeater)e.Item.FindControl("rptAccordianConcept");
        Repeater childRepeaterForHabit = (Repeater)e.Item.FindControl("rptAccordianHabit");
        Repeater childRepeaterForPractice = (Repeater)e.Item.FindControl("rptAccordianPractice");
        HtmlGenericControl saHabitsDiv= e.Item.FindControl("saHabitsDiv") as HtmlGenericControl;
        HtmlGenericControl saPracticesDiv= e.Item.FindControl("saPracticesDiv") as HtmlGenericControl;
        HtmlGenericControl saConceptsDiv= e.Item.FindControl("saConceptsDiv") as HtmlGenericControl;

        try
        {
            using (SqlConnection conChild = new SqlConnection(conStr))
            {  
                using (SqlCommand cmdChildConcept = new SqlCommand())
                {
                    cmdChildConcept.CommandText = "select C.ConceptName, ROUND(AVG(Cast(QC.AlignmentRating as Float)), 1) as AvgConceptAlignmentRating from ct_questions.CT_QuestionConcept QC LEFT JOIN ct_questions.CT_Concepts C ON QC.ConceptID=C.ConceptID WHERE QuestionID = @QuesID GROUP BY C.ConceptName, QC.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildConcept.Parameters.Add(param);
                    cmdChildConcept.Connection = conChild;
                    conChild.Open();
                    childRepeaterForConcept.DataSource = cmdChildConcept.ExecuteReader();
                    childRepeaterForConcept.DataBind();
                    if(childRepeaterForConcept.Items.Count<1)
                    {
                        saConceptsDiv.Visible = false;
                    }
                    conChild.Close();
                }
                using (SqlCommand cmdChildHabit = new SqlCommand())
                {
                    cmdChildHabit.CommandText = "select H.HabitName, ROUND(AVG(Cast(QH.AlignmentRating as Float)), 1) as AvgHabitAlignmentRating from ct_questions.CT_QuestionHabit QH LEFT JOIN ct_questions.CT_Habits H ON QH.HabitID=H.HabitID WHERE QuestionID = @QuesID GROUP BY H.HabitName, QH.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildHabit.Parameters.Add(param);

                    cmdChildHabit.Connection = conChild;
                    conChild.Open();
                    childRepeaterForHabit.DataSource = cmdChildHabit.ExecuteReader();
                    childRepeaterForHabit.DataBind();
                    if(childRepeaterForHabit.Items.Count<1)
                    {
                        saHabitsDiv.Visible = false;
                    }
                    conChild.Close();
                }
                using (SqlCommand cmdChildPractice = new SqlCommand())
                {
                    cmdChildPractice.CommandText = "select P.PracticeName, ROUND(AVG(Cast(QP.AlignmentRating as Float)), 1) as AvgPracticeAlignmentRating from ct_questions.CT_QuestionPractice QP LEFT JOIN ct_questions.CT_Practices P ON QP.PracticeID=P.PracticeID WHERE QuestionID = @QuesID GROUP BY P.PracticeName, QP.QuestionID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@QuesID";
                    param.Value = hfQuestionID;
                    cmdChildPractice.Parameters.Add(param);

                    cmdChildPractice.Connection = conChild;
                    conChild.Open();
                    childRepeaterForPractice.DataSource = cmdChildPractice.ExecuteReader();
                    childRepeaterForPractice.DataBind();
                    if(childRepeaterForPractice.Items.Count<1)
                    {
                        saPracticesDiv.Visible = false;
                    }
                    conChild.Close();
                }
                using (SqlCommand cmdChildContName = new SqlCommand())
                {
                    cmdChildContName.CommandText = "select ContributorName from ct_questions.CT_Contributors WHERE ContributorID = @hfContributorID";
                    SqlParameter param = new SqlParameter();
                    param.ParameterName = "@hfContributorID";
                    param.Value = hfContributorID;
                    cmdChildContName.Parameters.Add(param);

                    cmdChildContName.Connection = conChild;
                    conChild.Open();
                    contName = (string)cmdChildContName.ExecuteScalar();
                    contNameLabel.Text=contName;
                    conChild.Close();
                }
            }

        }
        catch (System.Data.SqlClient.SqlException exception)
        {

            lblErr.Text = "Error occured! Please try again! : " + exception.StackTrace;
        }
        catch (Exception exception)
        {

            lblErr.Text = "Error occured! Please try again!: " + exception.ToString();
        }

    }

    protected void logout(object sender, EventArgs e)
    {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
            Response.Redirect("Default.aspx");
    }

    protected void goBack(object sender, EventArgs e)
    {
        // Adapt page depending on role
            int role = Convert.ToInt32(Session["Role"].ToString());
            //Admin
            if (role == 1)
            {
                Response.Redirect("CTAdminLanding.aspx");
            }
            else if(role==2){
                Response.Redirect("CTTeacherLanding.aspx");
            }
            else{
                Response.Redirect("CTLanding.aspx");
            }
        
    }




}