﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using System.Data.OleDb;
using System.Collections.Generic;    
using System.Linq;    
using System.Text;    
using System.Security.Cryptography;    
using System.IO;    
using System.Web.Helpers;

    public partial class CTLogin : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            string msg = Request.QueryString["err"];
            lblErr.Text = msg;

            string msg2 = Request.QueryString["msg"];
            lblResult.Text = msg2;

            string msg3 = Request.QueryString["logout"];
            ClearAll();
        }

        protected void btnLogin_Click(object sender, EventArgs e)
        {

            string sql = "";
            lblErr.Text = "";

            // Set up a regular expression to filter out invalid name characters.
            Regex myFilter = new Regex("[0-9a-zA-Z-_]");

            string user = txtUsername.Text;

            if (user == "")
            {
                lblResult.Text = "User name is required.";
                txtUsername.Focus();
                return;
            }


            if (!myFilter.IsMatch(user))
            {
                lblResult.Text = "Please enter a combination of letters, numbers and special characters (-, _)";
                return;
            }

            string pass = txtPassword.Text;

            if (pass == "")
            {
                lblResult.Text = "Password is required.";
                txtPassword.Focus();
                return;
            }

            myFilter = new Regex("[0-9a-zA-Z'-_!]*");

            if (!myFilter.IsMatch(pass))
            {
                lblResult.Text = "Please enter a combination of letters, numbers and special characters (', -, _, !)";
                return;
            }

            // Look for user in DB
            OleDbConnection db = new OleDbConnection();

            db.ConnectionString = ConfigurationManager.ConnectionStrings["techfitConnectionString"].ConnectionString;

            try
            {
                db.Open();

                sql = "SELECT * FROM ct_questions.CT_Contributors WHERE [Username] = " + toSQL(user);

                OleDbCommand cmd = new OleDbCommand(sql, db);
                OleDbDataReader rdr = cmd.ExecuteReader();

                // If a match is found, assign the session variable to signify authorized.
                if (rdr.Read() == true) 
                {
                    if(Crypto.VerifyHashedPassword(rdr["Password"].ToString(), pass)){
                        Session["ContributorID"] = rdr["ContributorID"].ToString();
                        Session["ContributorName"] = rdr["ContributorName"].ToString();
                        Session["ContributorWelcomeMsg"] = "Welcome " + rdr["ContributorName"].ToString() + "!";
                        Session["Role"] = rdr["Role"].ToString();
                        if(rdr["GradeLevel"].ToString()!=null)
                            Session["GradeLevel"] = rdr["GradeLevel"].ToString();
                        else
                            Session["GradeLevel"] = null;
                        // Only if authorized, reroute to the homepage
                        if (Session["Role"].ToString() == "1")
                        {
                            Response.Redirect("CTAdminLanding.aspx");
                        } else if (Session["Role"].ToString() == "2"){
                            Response.Redirect("CTTeacherLanding.aspx");
                        } else if (Session["Role"].ToString() == "3"){
                            Response.Redirect("CTStudentLanding.aspx");
                        } else{
                            Response.Redirect("CTLanding.aspx");
                        }
                    } else{
                        ClearAll();
                        Response.Redirect("Default.aspx?msg=Invalid credentials!");
                    }
                    
                }
                else
                {
                    ClearAll();
                    Response.Redirect("Default.aspx?msg=Invalid credentials!");
                }

                rdr.Close();
            }
            catch (Exception err)
            {
                lblResult.Text = "ERROR: There was a problem - " + err.Message + err.StackTrace;
            }
            finally
            {
                db.Close();
            }
        }

        protected void btnSignup_Click(object sender, EventArgs e)
        {  
            Response.Redirect("CTSignup.aspx");
        }

        protected void btnForgotPassword_Click(object sender, EventArgs e)
        {  
            Response.Redirect("CTForgotPassword.aspx");
        }

        private void ClearAll()
        {
            Session["ContributorID"] = null;
            Session["ContributorName"] = null;
            Session["ContributorWelcomeMsg"] = null;
            Session["Role"] = null;
            Session["questionID"] = null;
            Session["questionType"] = null;
            Session["UserID"] = null;
            Session["Name"] = null;
            Session["Type"] = null;
            Session["GradeLevel"] = null;
            Session["score"] = null;
            Session["studentID"] = null;
            Session["correctAnswerListAsString"] = null;
            Session["incorrectAnswerListAsString"] = null;
        }

        // Helper method to filter the user's input
        private string toSQL(string stringValue)
        {
            string temp = stringValue.Replace("'", "''");
            temp = temp.Replace("<", "");
            temp = temp.Replace(">", "");
            temp = temp.Replace(";", " ");
            temp = temp.Replace(" OR ", " ");

            return "'" + temp + "'";
        }

    
    }